/*
 * File:           C:\Phil\Electronics\CAD\Dig_Cross_2011\adau_FILES\Dig_Cross_2012_IC_1_PARAM.h
 *
 * Created:        Thursday, January 26, 2012 11:50:59 AM
 * Description:    ADAU1442_Program:IC 1 parameter RAM definitions.
 *
 * This software is distributed in the hope that it will be useful,
 * but is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * This software may only be used to program products purchased from
 * Analog Devices for incorporation by you into audio products that
 * are intended for resale to audio product end users. This software
 * may not be distributed whole or in any part to third parties.
 *
 * Copyright © 2012 Analog Devices, Inc. All rights reserved.
 */
#ifndef __DIG_CROSS_2012_IC_1_PARAM_H__
#define __DIG_CROSS_2012_IC_1_PARAM_H__


/* Module Modulo Size - Modulo Size*/
#define MOD_MODULOSIZE_COUNT                           1
#define MOD_MODULOSIZE_DEVICE                          "IC1"
#define MOD_MODULOSIZE_MODULO_SIZE_ADDR                0
#define MOD_MODULOSIZE_MODULO_SIZE_FIXPT               0x00002000
#define MOD_MODULOSIZE_MODULO_SIZE_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(8192)
#define MOD_MODULOSIZE_MODULO_SIZE_TYPE                SIGMASTUDIOTYPE_INTEGER

/* Module INPUT_SEL - Stereo Switch Nx2*/
#define MOD_INPUT_SEL_COUNT                            2
#define MOD_INPUT_SEL_DEVICE                           "IC1"
#define MOD_INPUT_SEL_ALG0_STAGE0_STEREOSWITCHNOSLEW_ADDR 8
#define MOD_INPUT_SEL_ALG0_STAGE0_STEREOSWITCHNOSLEW_FIXPT 0x00800000
#define MOD_INPUT_SEL_ALG0_STAGE0_STEREOSWITCHNOSLEW_VALUE SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_INPUT_SEL_ALG0_STAGE0_STEREOSWITCHNOSLEW_TYPE SIGMASTUDIOTYPE_FIXPOINT
#define MOD_INPUT_SEL_ALG0_STAGE1_STEREOSWITCHNOSLEW_ADDR 9
#define MOD_INPUT_SEL_ALG0_STAGE1_STEREOSWITCHNOSLEW_FIXPT 0x00000000
#define MOD_INPUT_SEL_ALG0_STAGE1_STEREOSWITCHNOSLEW_VALUE SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_INPUT_SEL_ALG0_STAGE1_STEREOSWITCHNOSLEW_TYPE SIGMASTUDIOTYPE_FIXPOINT

/* Module DCB1 - DC Blocking*/
#define MOD_DCB1_COUNT                                 1
#define MOD_DCB1_DEVICE                                "IC1"
#define MOD_DCB1_DCBALGDOUPREC1POLE_ADDR               10
#define MOD_DCB1_DCBALGDOUPREC1POLE_FIXPT              0x007FFCB9
#define MOD_DCB1_DCBALGDOUPREC1POLE_VALUE              SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.9999)
#define MOD_DCB1_DCBALGDOUPREC1POLE_TYPE               SIGMASTUDIOTYPE_FIXPOINT

/* Module DCB2 - DC Blocking*/
#define MOD_DCB2_COUNT                                 1
#define MOD_DCB2_DEVICE                                "IC1"
#define MOD_DCB2_DCBALGDOUPREC2POLE_ADDR               11
#define MOD_DCB2_DCBALGDOUPREC2POLE_FIXPT              0x007FFCB9
#define MOD_DCB2_DCBALGDOUPREC2POLE_VALUE              SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.9999)
#define MOD_DCB2_DCBALGDOUPREC2POLE_TYPE               SIGMASTUDIOTYPE_FIXPOINT

/* Module COMM_FILT0 - General (2nd order)*/
#define MOD_COMM_FILT0_COUNT                           9
#define MOD_COMM_FILT0_DEVICE                          "IC1"
#define MOD_COMM_FILT0_ALG0_STAGE0_B2_ADDR             12
#define MOD_COMM_FILT0_ALG0_STAGE0_B2_FIXPT            0x00000000
#define MOD_COMM_FILT0_ALG0_STAGE0_B2_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT0_ALG0_STAGE0_B2_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT0_ALG0_STAGE0_B1_ADDR             13
#define MOD_COMM_FILT0_ALG0_STAGE0_B1_FIXPT            0x00000000
#define MOD_COMM_FILT0_ALG0_STAGE0_B1_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT0_ALG0_STAGE0_B1_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT0_ALG0_STAGE0_B0_ADDR             14
#define MOD_COMM_FILT0_ALG0_STAGE0_B0_FIXPT            0x00800000
#define MOD_COMM_FILT0_ALG0_STAGE0_B0_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_COMM_FILT0_ALG0_STAGE0_B0_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT0_ALG0_STAGE0_A2_ADDR             15
#define MOD_COMM_FILT0_ALG0_STAGE0_A2_FIXPT            0x00000000
#define MOD_COMM_FILT0_ALG0_STAGE0_A2_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT0_ALG0_STAGE0_A2_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT0_ALG0_STAGE0_A1_ADDR             16
#define MOD_COMM_FILT0_ALG0_STAGE0_A1_FIXPT            0x00000000
#define MOD_COMM_FILT0_ALG0_STAGE0_A1_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT0_ALG0_STAGE0_A1_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT0_ALG0_DATA_ADR_ADDR              17
#define MOD_COMM_FILT0_ALG0_DATA_ADR_FIXPT             0x00000017
#define MOD_COMM_FILT0_ALG0_DATA_ADR_VALUE             SIGMASTUDIOTYPE_INTEGER_CONVERT(23)
#define MOD_COMM_FILT0_ALG0_DATA_ADR_TYPE              SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT0_ALG0_DATAR_ADR_ADDR             18
#define MOD_COMM_FILT0_ALG0_DATAR_ADR_FIXPT            0x00000020
#define MOD_COMM_FILT0_ALG0_DATAR_ADR_VALUE            SIGMASTUDIOTYPE_INTEGER_CONVERT(32)
#define MOD_COMM_FILT0_ALG0_DATAR_ADR_TYPE             SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT0_ALG0_COEFF_ADR_ADDR             19
#define MOD_COMM_FILT0_ALG0_COEFF_ADR_FIXPT            0x0000000F
#define MOD_COMM_FILT0_ALG0_COEFF_ADR_VALUE            SIGMASTUDIOTYPE_INTEGER_CONVERT(15)
#define MOD_COMM_FILT0_ALG0_COEFF_ADR_TYPE             SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT0_ALG0_LOOP_ADDR                  20
#define MOD_COMM_FILT0_ALG0_LOOP_FIXPT                 0x00000001
#define MOD_COMM_FILT0_ALG0_LOOP_VALUE                 SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_COMM_FILT0_ALG0_LOOP_TYPE                  SIGMASTUDIOTYPE_INTEGER

/* Module COMM_FILT1 - General (2nd order)*/
#define MOD_COMM_FILT1_COUNT                           9
#define MOD_COMM_FILT1_DEVICE                          "IC1"
#define MOD_COMM_FILT1_ALG0_STAGE0_B2_ADDR             21
#define MOD_COMM_FILT1_ALG0_STAGE0_B2_FIXPT            0x00000000
#define MOD_COMM_FILT1_ALG0_STAGE0_B2_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT1_ALG0_STAGE0_B2_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT1_ALG0_STAGE0_B1_ADDR             22
#define MOD_COMM_FILT1_ALG0_STAGE0_B1_FIXPT            0x00000000
#define MOD_COMM_FILT1_ALG0_STAGE0_B1_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT1_ALG0_STAGE0_B1_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT1_ALG0_STAGE0_B0_ADDR             23
#define MOD_COMM_FILT1_ALG0_STAGE0_B0_FIXPT            0x00800000
#define MOD_COMM_FILT1_ALG0_STAGE0_B0_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_COMM_FILT1_ALG0_STAGE0_B0_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT1_ALG0_STAGE0_A2_ADDR             24
#define MOD_COMM_FILT1_ALG0_STAGE0_A2_FIXPT            0x00000000
#define MOD_COMM_FILT1_ALG0_STAGE0_A2_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT1_ALG0_STAGE0_A2_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT1_ALG0_STAGE0_A1_ADDR             25
#define MOD_COMM_FILT1_ALG0_STAGE0_A1_FIXPT            0x00000000
#define MOD_COMM_FILT1_ALG0_STAGE0_A1_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT1_ALG0_STAGE0_A1_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT1_ALG0_DATA_ADR_ADDR              26
#define MOD_COMM_FILT1_ALG0_DATA_ADR_FIXPT             0x0000002B
#define MOD_COMM_FILT1_ALG0_DATA_ADR_VALUE             SIGMASTUDIOTYPE_INTEGER_CONVERT(43)
#define MOD_COMM_FILT1_ALG0_DATA_ADR_TYPE              SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT1_ALG0_DATAR_ADR_ADDR             27
#define MOD_COMM_FILT1_ALG0_DATAR_ADR_FIXPT            0x00000034
#define MOD_COMM_FILT1_ALG0_DATAR_ADR_VALUE            SIGMASTUDIOTYPE_INTEGER_CONVERT(52)
#define MOD_COMM_FILT1_ALG0_DATAR_ADR_TYPE             SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT1_ALG0_COEFF_ADR_ADDR             28
#define MOD_COMM_FILT1_ALG0_COEFF_ADR_FIXPT            0x00000018
#define MOD_COMM_FILT1_ALG0_COEFF_ADR_VALUE            SIGMASTUDIOTYPE_INTEGER_CONVERT(24)
#define MOD_COMM_FILT1_ALG0_COEFF_ADR_TYPE             SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT1_ALG0_LOOP_ADDR                  29
#define MOD_COMM_FILT1_ALG0_LOOP_FIXPT                 0x00000001
#define MOD_COMM_FILT1_ALG0_LOOP_VALUE                 SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_COMM_FILT1_ALG0_LOOP_TYPE                  SIGMASTUDIOTYPE_INTEGER

/* Module COMM_FILT2 - General (2nd order)*/
#define MOD_COMM_FILT2_COUNT                           9
#define MOD_COMM_FILT2_DEVICE                          "IC1"
#define MOD_COMM_FILT2_ALG0_STAGE0_B2_ADDR             30
#define MOD_COMM_FILT2_ALG0_STAGE0_B2_FIXPT            0x00000000
#define MOD_COMM_FILT2_ALG0_STAGE0_B2_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT2_ALG0_STAGE0_B2_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT2_ALG0_STAGE0_B1_ADDR             31
#define MOD_COMM_FILT2_ALG0_STAGE0_B1_FIXPT            0x00000000
#define MOD_COMM_FILT2_ALG0_STAGE0_B1_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT2_ALG0_STAGE0_B1_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT2_ALG0_STAGE0_B0_ADDR             32
#define MOD_COMM_FILT2_ALG0_STAGE0_B0_FIXPT            0x00800000
#define MOD_COMM_FILT2_ALG0_STAGE0_B0_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_COMM_FILT2_ALG0_STAGE0_B0_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT2_ALG0_STAGE0_A2_ADDR             33
#define MOD_COMM_FILT2_ALG0_STAGE0_A2_FIXPT            0x00000000
#define MOD_COMM_FILT2_ALG0_STAGE0_A2_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT2_ALG0_STAGE0_A2_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT2_ALG0_STAGE0_A1_ADDR             34
#define MOD_COMM_FILT2_ALG0_STAGE0_A1_FIXPT            0x00000000
#define MOD_COMM_FILT2_ALG0_STAGE0_A1_VALUE            SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_COMM_FILT2_ALG0_STAGE0_A1_TYPE             SIGMASTUDIOTYPE_FIXPOINT
#define MOD_COMM_FILT2_ALG0_DATA_ADR_ADDR              35
#define MOD_COMM_FILT2_ALG0_DATA_ADR_FIXPT             0x0000003F
#define MOD_COMM_FILT2_ALG0_DATA_ADR_VALUE             SIGMASTUDIOTYPE_INTEGER_CONVERT(63)
#define MOD_COMM_FILT2_ALG0_DATA_ADR_TYPE              SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT2_ALG0_DATAR_ADR_ADDR             36
#define MOD_COMM_FILT2_ALG0_DATAR_ADR_FIXPT            0x00000048
#define MOD_COMM_FILT2_ALG0_DATAR_ADR_VALUE            SIGMASTUDIOTYPE_INTEGER_CONVERT(72)
#define MOD_COMM_FILT2_ALG0_DATAR_ADR_TYPE             SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT2_ALG0_COEFF_ADR_ADDR             37
#define MOD_COMM_FILT2_ALG0_COEFF_ADR_FIXPT            0x00000021
#define MOD_COMM_FILT2_ALG0_COEFF_ADR_VALUE            SIGMASTUDIOTYPE_INTEGER_CONVERT(33)
#define MOD_COMM_FILT2_ALG0_COEFF_ADR_TYPE             SIGMASTUDIOTYPE_INTEGER
#define MOD_COMM_FILT2_ALG0_LOOP_ADDR                  38
#define MOD_COMM_FILT2_ALG0_LOOP_FIXPT                 0x00000001
#define MOD_COMM_FILT2_ALG0_LOOP_VALUE                 SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_COMM_FILT2_ALG0_LOOP_TYPE                  SIGMASTUDIOTYPE_INTEGER

/* Module B0_HPF0 - General (2nd order)*/
#define MOD_B0_HPF0_COUNT                              9
#define MOD_B0_HPF0_DEVICE                             "IC1"
#define MOD_B0_HPF0_ALG0_STAGE0_B2_ADDR                39
#define MOD_B0_HPF0_ALG0_STAGE0_B2_FIXPT               0x007FE1AF
#define MOD_B0_HPF0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.999074827623903)
#define MOD_B0_HPF0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF0_ALG0_STAGE0_B1_ADDR                40
#define MOD_B0_HPF0_ALG0_STAGE0_B1_FIXPT               0xFF003CA2
#define MOD_B0_HPF0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.99814965524781)
#define MOD_B0_HPF0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF0_ALG0_STAGE0_B0_ADDR                41
#define MOD_B0_HPF0_ALG0_STAGE0_B0_FIXPT               0x007FE1AF
#define MOD_B0_HPF0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.999074827623903)
#define MOD_B0_HPF0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF0_ALG0_STAGE0_A2_ADDR                42
#define MOD_B0_HPF0_ALG0_STAGE0_A2_FIXPT               0xFF803C9B
#define MOD_B0_HPF0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.998150511191915)
#define MOD_B0_HPF0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF0_ALG0_STAGE0_A1_ADDR                43
#define MOD_B0_HPF0_ALG0_STAGE0_A1_FIXPT               0x00FFC357
#define MOD_B0_HPF0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.9981487993037)
#define MOD_B0_HPF0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF0_ALG0_DATA_ADR_ADDR                 44
#define MOD_B0_HPF0_ALG0_DATA_ADR_FIXPT                0x00000053
#define MOD_B0_HPF0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(83)
#define MOD_B0_HPF0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF0_ALG0_DATAR_ADR_ADDR                45
#define MOD_B0_HPF0_ALG0_DATAR_ADR_FIXPT               0x0000005C
#define MOD_B0_HPF0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(92)
#define MOD_B0_HPF0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF0_ALG0_COEFF_ADR_ADDR                46
#define MOD_B0_HPF0_ALG0_COEFF_ADR_FIXPT               0x0000002A
#define MOD_B0_HPF0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(42)
#define MOD_B0_HPF0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF0_ALG0_LOOP_ADDR                     47
#define MOD_B0_HPF0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_HPF0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_HPF0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_HPF0 - General (2nd order)*/
#define MOD_B1_HPF0_COUNT                              9
#define MOD_B1_HPF0_DEVICE                             "IC1"
#define MOD_B1_HPF0_ALG0_STAGE0_B2_ADDR                48
#define MOD_B1_HPF0_ALG0_STAGE0_B2_FIXPT               0x007ED89C
#define MOD_B1_HPF0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.990985504551523)
#define MOD_B1_HPF0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF0_ALG0_STAGE0_B1_ADDR                49
#define MOD_B1_HPF0_ALG0_STAGE0_B1_FIXPT               0xFF024EC7
#define MOD_B1_HPF0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.98197100910305)
#define MOD_B1_HPF0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF0_ALG0_STAGE0_B0_ADDR                50
#define MOD_B1_HPF0_ALG0_STAGE0_B0_FIXPT               0x007ED89C
#define MOD_B1_HPF0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.990985504551523)
#define MOD_B1_HPF0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF0_ALG0_STAGE0_A2_ADDR                51
#define MOD_B1_HPF0_ALG0_STAGE0_A2_FIXPT               0xFF824CFF
#define MOD_B1_HPF0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.982025346956718)
#define MOD_B1_HPF0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF0_ALG0_STAGE0_A1_ADDR                52
#define MOD_B1_HPF0_ALG0_STAGE0_A1_FIXPT               0x00FDAF72
#define MOD_B1_HPF0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.98191667124937)
#define MOD_B1_HPF0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF0_ALG0_DATA_ADR_ADDR                 53
#define MOD_B1_HPF0_ALG0_DATA_ADR_FIXPT                0x00000067
#define MOD_B1_HPF0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(103)
#define MOD_B1_HPF0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF0_ALG0_DATAR_ADR_ADDR                54
#define MOD_B1_HPF0_ALG0_DATAR_ADR_FIXPT               0x00000070
#define MOD_B1_HPF0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(112)
#define MOD_B1_HPF0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF0_ALG0_COEFF_ADR_ADDR                55
#define MOD_B1_HPF0_ALG0_COEFF_ADR_FIXPT               0x00000033
#define MOD_B1_HPF0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(51)
#define MOD_B1_HPF0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF0_ALG0_LOOP_ADDR                     56
#define MOD_B1_HPF0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_HPF0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_HPF0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_HPF0 - General (2nd order)*/
#define MOD_B2_HPF0_COUNT                              9
#define MOD_B2_HPF0_DEVICE                             "IC1"
#define MOD_B2_HPF0_ALG0_STAGE0_B2_ADDR                57
#define MOD_B2_HPF0_ALG0_STAGE0_B2_FIXPT               0x00728ABA
#define MOD_B2_HPF0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.894858606122573)
#define MOD_B2_HPF0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF0_ALG0_STAGE0_B1_ADDR                58
#define MOD_B2_HPF0_ALG0_STAGE0_B1_FIXPT               0xFF1AEA8C
#define MOD_B2_HPF0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.78971721224515)
#define MOD_B2_HPF0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF0_ALG0_STAGE0_B0_ADDR                59
#define MOD_B2_HPF0_ALG0_STAGE0_B0_FIXPT               0x00728ABA
#define MOD_B2_HPF0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.894858606122573)
#define MOD_B2_HPF0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF0_ALG0_STAGE0_A2_ADDR                60
#define MOD_B2_HPF0_ALG0_STAGE0_A2_FIXPT               0xFF997F4D
#define MOD_B2_HPF0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.800802646665708)
#define MOD_B2_HPF0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF0_ALG0_STAGE0_A1_ADDR                61
#define MOD_B2_HPF0_ALG0_STAGE0_A1_FIXPT               0x00E3AA34
#define MOD_B2_HPF0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.77863177782459)
#define MOD_B2_HPF0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF0_ALG0_DATA_ADR_ADDR                 62
#define MOD_B2_HPF0_ALG0_DATA_ADR_FIXPT                0x0000007B
#define MOD_B2_HPF0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(123)
#define MOD_B2_HPF0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF0_ALG0_DATAR_ADR_ADDR                63
#define MOD_B2_HPF0_ALG0_DATAR_ADR_FIXPT               0x00000084
#define MOD_B2_HPF0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(132)
#define MOD_B2_HPF0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF0_ALG0_COEFF_ADR_ADDR                64
#define MOD_B2_HPF0_ALG0_COEFF_ADR_FIXPT               0x0000003C
#define MOD_B2_HPF0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(60)
#define MOD_B2_HPF0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF0_ALG0_LOOP_ADDR                     65
#define MOD_B2_HPF0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_HPF0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_HPF0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_HPF0 - General (2nd order)*/
#define MOD_B3_HPF0_COUNT                              9
#define MOD_B3_HPF0_DEVICE                             "IC1"
#define MOD_B3_HPF0_ALG0_STAGE0_B2_ADDR                66
#define MOD_B3_HPF0_ALG0_STAGE0_B2_FIXPT               0x0043C2A2
#define MOD_B3_HPF0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.529377314878827)
#define MOD_B3_HPF0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF0_ALG0_STAGE0_B1_ADDR                67
#define MOD_B3_HPF0_ALG0_STAGE0_B1_FIXPT               0xFF787ABB
#define MOD_B3_HPF0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.05875462975765)
#define MOD_B3_HPF0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF0_ALG0_STAGE0_B0_ADDR                68
#define MOD_B3_HPF0_ALG0_STAGE0_B0_FIXPT               0x0043C2A2
#define MOD_B3_HPF0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.529377314878827)
#define MOD_B3_HPF0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF0_ALG0_STAGE0_A2_ADDR                69
#define MOD_B3_HPF0_ALG0_STAGE0_A2_FIXPT               0xFFE13A4E
#define MOD_B3_HPF0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.240408205773458)
#define MOD_B3_HPF0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF0_ALG0_STAGE0_A1_ADDR                70
#define MOD_B3_HPF0_ALG0_STAGE0_A1_FIXPT               0x007044D8
#define MOD_B3_HPF0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.87710105374185)
#define MOD_B3_HPF0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF0_ALG0_DATA_ADR_ADDR                 71
#define MOD_B3_HPF0_ALG0_DATA_ADR_FIXPT                0x0000008F
#define MOD_B3_HPF0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(143)
#define MOD_B3_HPF0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF0_ALG0_DATAR_ADR_ADDR                72
#define MOD_B3_HPF0_ALG0_DATAR_ADR_FIXPT               0x00000098
#define MOD_B3_HPF0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(152)
#define MOD_B3_HPF0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF0_ALG0_COEFF_ADR_ADDR                73
#define MOD_B3_HPF0_ALG0_COEFF_ADR_FIXPT               0x00000045
#define MOD_B3_HPF0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(69)
#define MOD_B3_HPF0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF0_ALG0_LOOP_ADDR                     74
#define MOD_B3_HPF0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_HPF0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_HPF0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_HPF1 - General (2nd order)*/
#define MOD_B0_HPF1_COUNT                              9
#define MOD_B0_HPF1_DEVICE                             "IC1"
#define MOD_B0_HPF1_ALG0_STAGE0_B2_ADDR                75
#define MOD_B0_HPF1_ALG0_STAGE0_B2_FIXPT               0x007FDAE1
#define MOD_B0_HPF1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.998867231486796)
#define MOD_B0_HPF1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF1_ALG0_STAGE0_B1_ADDR                76
#define MOD_B0_HPF1_ALG0_STAGE0_B1_FIXPT               0xFF004A3D
#define MOD_B0_HPF1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.99773446297359)
#define MOD_B0_HPF1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF1_ALG0_STAGE0_B0_ADDR                77
#define MOD_B0_HPF1_ALG0_STAGE0_B0_FIXPT               0x007FDAE1
#define MOD_B0_HPF1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.998867231486796)
#define MOD_B0_HPF1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF1_ALG0_STAGE0_A2_ADDR                78
#define MOD_B0_HPF1_ALG0_STAGE0_A2_FIXPT               0xFF804A36
#define MOD_B0_HPF1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.997735318739846)
#define MOD_B0_HPF1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF1_ALG0_STAGE0_A1_ADDR                79
#define MOD_B0_HPF1_ALG0_STAGE0_A1_FIXPT               0x00FFB5BC
#define MOD_B0_HPF1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.99773360720734)
#define MOD_B0_HPF1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF1_ALG0_DATA_ADR_ADDR                 80
#define MOD_B0_HPF1_ALG0_DATA_ADR_FIXPT                0x000000A3
#define MOD_B0_HPF1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(163)
#define MOD_B0_HPF1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF1_ALG0_DATAR_ADR_ADDR                81
#define MOD_B0_HPF1_ALG0_DATAR_ADR_FIXPT               0x000000AC
#define MOD_B0_HPF1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(172)
#define MOD_B0_HPF1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF1_ALG0_COEFF_ADR_ADDR                82
#define MOD_B0_HPF1_ALG0_COEFF_ADR_FIXPT               0x0000004E
#define MOD_B0_HPF1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(78)
#define MOD_B0_HPF1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF1_ALG0_LOOP_ADDR                     83
#define MOD_B0_HPF1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_HPF1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_HPF1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_HPF1 - General (2nd order)*/
#define MOD_B1_HPF1_COUNT                              9
#define MOD_B1_HPF1_DEVICE                             "IC1"
#define MOD_B1_HPF1_ALG0_STAGE0_B2_ADDR                84
#define MOD_B1_HPF1_ALG0_STAGE0_B2_FIXPT               0x007ED89C
#define MOD_B1_HPF1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.990985504551523)
#define MOD_B1_HPF1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF1_ALG0_STAGE0_B1_ADDR                85
#define MOD_B1_HPF1_ALG0_STAGE0_B1_FIXPT               0xFF024EC7
#define MOD_B1_HPF1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.98197100910305)
#define MOD_B1_HPF1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF1_ALG0_STAGE0_B0_ADDR                86
#define MOD_B1_HPF1_ALG0_STAGE0_B0_FIXPT               0x007ED89C
#define MOD_B1_HPF1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.990985504551523)
#define MOD_B1_HPF1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF1_ALG0_STAGE0_A2_ADDR                87
#define MOD_B1_HPF1_ALG0_STAGE0_A2_FIXPT               0xFF824CFF
#define MOD_B1_HPF1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.982025346956718)
#define MOD_B1_HPF1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF1_ALG0_STAGE0_A1_ADDR                88
#define MOD_B1_HPF1_ALG0_STAGE0_A1_FIXPT               0x00FDAF72
#define MOD_B1_HPF1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.98191667124937)
#define MOD_B1_HPF1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF1_ALG0_DATA_ADR_ADDR                 89
#define MOD_B1_HPF1_ALG0_DATA_ADR_FIXPT                0x000000B7
#define MOD_B1_HPF1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(183)
#define MOD_B1_HPF1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF1_ALG0_DATAR_ADR_ADDR                90
#define MOD_B1_HPF1_ALG0_DATAR_ADR_FIXPT               0x000000C0
#define MOD_B1_HPF1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(192)
#define MOD_B1_HPF1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF1_ALG0_COEFF_ADR_ADDR                91
#define MOD_B1_HPF1_ALG0_COEFF_ADR_FIXPT               0x00000057
#define MOD_B1_HPF1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(87)
#define MOD_B1_HPF1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF1_ALG0_LOOP_ADDR                     92
#define MOD_B1_HPF1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_HPF1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_HPF1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_HPF1 - General (2nd order)*/
#define MOD_B2_HPF1_COUNT                              9
#define MOD_B2_HPF1_DEVICE                             "IC1"
#define MOD_B2_HPF1_ALG0_STAGE0_B2_ADDR                93
#define MOD_B2_HPF1_ALG0_STAGE0_B2_FIXPT               0x007008BA
#define MOD_B2_HPF1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.87526638791179)
#define MOD_B2_HPF1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF1_ALG0_STAGE0_B1_ADDR                94
#define MOD_B2_HPF1_ALG0_STAGE0_B1_FIXPT               0xFF1FEE8B
#define MOD_B2_HPF1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.75053277582358)
#define MOD_B2_HPF1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF1_ALG0_STAGE0_B0_ADDR                95
#define MOD_B2_HPF1_ALG0_STAGE0_B0_FIXPT               0x007008BA
#define MOD_B2_HPF1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.87526638791179)
#define MOD_B2_HPF1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF1_ALG0_STAGE0_A2_ADDR                96
#define MOD_B2_HPF1_ALG0_STAGE0_A2_FIXPT               0xFF9E8B40
#define MOD_B2_HPF1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.761375503464945)
#define MOD_B2_HPF1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF1_ALG0_STAGE0_A1_ADDR                97
#define MOD_B2_HPF1_ALG0_STAGE0_A1_FIXPT               0x00DEAE29
#define MOD_B2_HPF1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.73969004818222)
#define MOD_B2_HPF1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF1_ALG0_DATA_ADR_ADDR                 98
#define MOD_B2_HPF1_ALG0_DATA_ADR_FIXPT                0x000000CB
#define MOD_B2_HPF1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(203)
#define MOD_B2_HPF1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF1_ALG0_DATAR_ADR_ADDR                99
#define MOD_B2_HPF1_ALG0_DATAR_ADR_FIXPT               0x000000D4
#define MOD_B2_HPF1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(212)
#define MOD_B2_HPF1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF1_ALG0_COEFF_ADR_ADDR                100
#define MOD_B2_HPF1_ALG0_COEFF_ADR_FIXPT               0x00000060
#define MOD_B2_HPF1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(96)
#define MOD_B2_HPF1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF1_ALG0_LOOP_ADDR                     101
#define MOD_B2_HPF1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_HPF1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_HPF1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_HPF1 - General (2nd order)*/
#define MOD_B3_HPF1_COUNT                              9
#define MOD_B3_HPF1_DEVICE                             "IC1"
#define MOD_B3_HPF1_ALG0_STAGE0_B2_ADDR                102
#define MOD_B3_HPF1_ALG0_STAGE0_B2_FIXPT               0x0043C2A2
#define MOD_B3_HPF1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.529377314878827)
#define MOD_B3_HPF1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF1_ALG0_STAGE0_B1_ADDR                103
#define MOD_B3_HPF1_ALG0_STAGE0_B1_FIXPT               0xFF787ABB
#define MOD_B3_HPF1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.05875462975765)
#define MOD_B3_HPF1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF1_ALG0_STAGE0_B0_ADDR                104
#define MOD_B3_HPF1_ALG0_STAGE0_B0_FIXPT               0x0043C2A2
#define MOD_B3_HPF1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.529377314878827)
#define MOD_B3_HPF1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF1_ALG0_STAGE0_A2_ADDR                105
#define MOD_B3_HPF1_ALG0_STAGE0_A2_FIXPT               0xFFE13A4E
#define MOD_B3_HPF1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.240408205773458)
#define MOD_B3_HPF1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF1_ALG0_STAGE0_A1_ADDR                106
#define MOD_B3_HPF1_ALG0_STAGE0_A1_FIXPT               0x007044D8
#define MOD_B3_HPF1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.87710105374185)
#define MOD_B3_HPF1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF1_ALG0_DATA_ADR_ADDR                 107
#define MOD_B3_HPF1_ALG0_DATA_ADR_FIXPT                0x000000DF
#define MOD_B3_HPF1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(223)
#define MOD_B3_HPF1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF1_ALG0_DATAR_ADR_ADDR                108
#define MOD_B3_HPF1_ALG0_DATAR_ADR_FIXPT               0x000000E8
#define MOD_B3_HPF1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(232)
#define MOD_B3_HPF1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF1_ALG0_COEFF_ADR_ADDR                109
#define MOD_B3_HPF1_ALG0_COEFF_ADR_FIXPT               0x00000069
#define MOD_B3_HPF1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(105)
#define MOD_B3_HPF1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF1_ALG0_LOOP_ADDR                     110
#define MOD_B3_HPF1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_HPF1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_HPF1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_HPF2 - General (2nd order)*/
#define MOD_B3_HPF2_COUNT                              9
#define MOD_B3_HPF2_DEVICE                             "IC1"
#define MOD_B3_HPF2_ALG0_STAGE0_B2_ADDR                111
#define MOD_B3_HPF2_ALG0_STAGE0_B2_FIXPT               0x0043C2A2
#define MOD_B3_HPF2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.529377314878827)
#define MOD_B3_HPF2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF2_ALG0_STAGE0_B1_ADDR                112
#define MOD_B3_HPF2_ALG0_STAGE0_B1_FIXPT               0xFF787ABB
#define MOD_B3_HPF2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.05875462975765)
#define MOD_B3_HPF2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF2_ALG0_STAGE0_B0_ADDR                113
#define MOD_B3_HPF2_ALG0_STAGE0_B0_FIXPT               0x0043C2A2
#define MOD_B3_HPF2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.529377314878827)
#define MOD_B3_HPF2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF2_ALG0_STAGE0_A2_ADDR                114
#define MOD_B3_HPF2_ALG0_STAGE0_A2_FIXPT               0xFFE13A4E
#define MOD_B3_HPF2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.240408205773458)
#define MOD_B3_HPF2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF2_ALG0_STAGE0_A1_ADDR                115
#define MOD_B3_HPF2_ALG0_STAGE0_A1_FIXPT               0x007044D8
#define MOD_B3_HPF2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.87710105374185)
#define MOD_B3_HPF2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF2_ALG0_DATA_ADR_ADDR                 116
#define MOD_B3_HPF2_ALG0_DATA_ADR_FIXPT                0x000000F3
#define MOD_B3_HPF2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(243)
#define MOD_B3_HPF2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF2_ALG0_DATAR_ADR_ADDR                117
#define MOD_B3_HPF2_ALG0_DATAR_ADR_FIXPT               0x000000FC
#define MOD_B3_HPF2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(252)
#define MOD_B3_HPF2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF2_ALG0_COEFF_ADR_ADDR                118
#define MOD_B3_HPF2_ALG0_COEFF_ADR_FIXPT               0x00000072
#define MOD_B3_HPF2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(114)
#define MOD_B3_HPF2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF2_ALG0_LOOP_ADDR                     119
#define MOD_B3_HPF2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_HPF2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_HPF2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_HPF2 - General (2nd order)*/
#define MOD_B2_HPF2_COUNT                              9
#define MOD_B2_HPF2_DEVICE                             "IC1"
#define MOD_B2_HPF2_ALG0_STAGE0_B2_ADDR                120
#define MOD_B2_HPF2_ALG0_STAGE0_B2_FIXPT               0x00728ABA
#define MOD_B2_HPF2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.894858606122573)
#define MOD_B2_HPF2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF2_ALG0_STAGE0_B1_ADDR                121
#define MOD_B2_HPF2_ALG0_STAGE0_B1_FIXPT               0xFF1AEA8C
#define MOD_B2_HPF2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.78971721224515)
#define MOD_B2_HPF2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF2_ALG0_STAGE0_B0_ADDR                122
#define MOD_B2_HPF2_ALG0_STAGE0_B0_FIXPT               0x00728ABA
#define MOD_B2_HPF2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.894858606122573)
#define MOD_B2_HPF2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF2_ALG0_STAGE0_A2_ADDR                123
#define MOD_B2_HPF2_ALG0_STAGE0_A2_FIXPT               0xFF997F4D
#define MOD_B2_HPF2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.800802646665708)
#define MOD_B2_HPF2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF2_ALG0_STAGE0_A1_ADDR                124
#define MOD_B2_HPF2_ALG0_STAGE0_A1_FIXPT               0x00E3AA34
#define MOD_B2_HPF2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.77863177782459)
#define MOD_B2_HPF2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF2_ALG0_DATA_ADR_ADDR                 125
#define MOD_B2_HPF2_ALG0_DATA_ADR_FIXPT                0x00000107
#define MOD_B2_HPF2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(263)
#define MOD_B2_HPF2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF2_ALG0_DATAR_ADR_ADDR                126
#define MOD_B2_HPF2_ALG0_DATAR_ADR_FIXPT               0x00000110
#define MOD_B2_HPF2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(272)
#define MOD_B2_HPF2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF2_ALG0_COEFF_ADR_ADDR                127
#define MOD_B2_HPF2_ALG0_COEFF_ADR_FIXPT               0x0000007B
#define MOD_B2_HPF2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(123)
#define MOD_B2_HPF2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF2_ALG0_LOOP_ADDR                     128
#define MOD_B2_HPF2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_HPF2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_HPF2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_HPF2 - General (2nd order)*/
#define MOD_B1_HPF2_COUNT                              9
#define MOD_B1_HPF2_DEVICE                             "IC1"
#define MOD_B1_HPF2_ALG0_STAGE0_B2_ADDR                129
#define MOD_B1_HPF2_ALG0_STAGE0_B2_FIXPT               0x007F0E41
#define MOD_B1_HPF2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.992622542756119)
#define MOD_B1_HPF2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF2_ALG0_STAGE0_B1_ADDR                130
#define MOD_B1_HPF2_ALG0_STAGE0_B1_FIXPT               0xFF01E37E
#define MOD_B1_HPF2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.98524508551224)
#define MOD_B1_HPF2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF2_ALG0_STAGE0_B0_ADDR                131
#define MOD_B1_HPF2_ALG0_STAGE0_B0_FIXPT               0x007F0E41
#define MOD_B1_HPF2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.992622542756119)
#define MOD_B1_HPF2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF2_ALG0_STAGE0_A2_ADDR                132
#define MOD_B1_HPF2_ALG0_STAGE0_A2_FIXPT               0xFF81E1B5
#define MOD_B1_HPF2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.985299513128215)
#define MOD_B1_HPF2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF2_ALG0_STAGE0_A1_ADDR                133
#define MOD_B1_HPF2_ALG0_STAGE0_A1_FIXPT               0x00FE1ABA
#define MOD_B1_HPF2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.98519065789626)
#define MOD_B1_HPF2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF2_ALG0_DATA_ADR_ADDR                 134
#define MOD_B1_HPF2_ALG0_DATA_ADR_FIXPT                0x0000011B
#define MOD_B1_HPF2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(283)
#define MOD_B1_HPF2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF2_ALG0_DATAR_ADR_ADDR                135
#define MOD_B1_HPF2_ALG0_DATAR_ADR_FIXPT               0x00000124
#define MOD_B1_HPF2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(292)
#define MOD_B1_HPF2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF2_ALG0_COEFF_ADR_ADDR                136
#define MOD_B1_HPF2_ALG0_COEFF_ADR_FIXPT               0x00000084
#define MOD_B1_HPF2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(132)
#define MOD_B1_HPF2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF2_ALG0_LOOP_ADDR                     137
#define MOD_B1_HPF2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_HPF2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_HPF2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_HPF2 - General (2nd order)*/
#define MOD_B0_HPF2_COUNT                              9
#define MOD_B0_HPF2_DEVICE                             "IC1"
#define MOD_B0_HPF2_ALG0_STAGE0_B2_ADDR                138
#define MOD_B0_HPF2_ALG0_STAGE0_B2_FIXPT               0x007FE1AF
#define MOD_B0_HPF2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.999074827623903)
#define MOD_B0_HPF2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF2_ALG0_STAGE0_B1_ADDR                139
#define MOD_B0_HPF2_ALG0_STAGE0_B1_FIXPT               0xFF003CA2
#define MOD_B0_HPF2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.99814965524781)
#define MOD_B0_HPF2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF2_ALG0_STAGE0_B0_ADDR                140
#define MOD_B0_HPF2_ALG0_STAGE0_B0_FIXPT               0x007FE1AF
#define MOD_B0_HPF2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.999074827623903)
#define MOD_B0_HPF2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF2_ALG0_STAGE0_A2_ADDR                141
#define MOD_B0_HPF2_ALG0_STAGE0_A2_FIXPT               0xFF803C9B
#define MOD_B0_HPF2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.998150511191915)
#define MOD_B0_HPF2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF2_ALG0_STAGE0_A1_ADDR                142
#define MOD_B0_HPF2_ALG0_STAGE0_A1_FIXPT               0x00FFC357
#define MOD_B0_HPF2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.9981487993037)
#define MOD_B0_HPF2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF2_ALG0_DATA_ADR_ADDR                 143
#define MOD_B0_HPF2_ALG0_DATA_ADR_FIXPT                0x0000012F
#define MOD_B0_HPF2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(303)
#define MOD_B0_HPF2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF2_ALG0_DATAR_ADR_ADDR                144
#define MOD_B0_HPF2_ALG0_DATAR_ADR_FIXPT               0x00000138
#define MOD_B0_HPF2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(312)
#define MOD_B0_HPF2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF2_ALG0_COEFF_ADR_ADDR                145
#define MOD_B0_HPF2_ALG0_COEFF_ADR_FIXPT               0x0000008D
#define MOD_B0_HPF2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(141)
#define MOD_B0_HPF2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF2_ALG0_LOOP_ADDR                     146
#define MOD_B0_HPF2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_HPF2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_HPF2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_HPF3 - General (2nd order)*/
#define MOD_B2_HPF3_COUNT                              9
#define MOD_B2_HPF3_DEVICE                             "IC1"
#define MOD_B2_HPF3_ALG0_STAGE0_B2_ADDR                147
#define MOD_B2_HPF3_ALG0_STAGE0_B2_FIXPT               0x007008BA
#define MOD_B2_HPF3_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.87526638791179)
#define MOD_B2_HPF3_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF3_ALG0_STAGE0_B1_ADDR                148
#define MOD_B2_HPF3_ALG0_STAGE0_B1_FIXPT               0xFF1FEE8B
#define MOD_B2_HPF3_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.75053277582358)
#define MOD_B2_HPF3_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF3_ALG0_STAGE0_B0_ADDR                149
#define MOD_B2_HPF3_ALG0_STAGE0_B0_FIXPT               0x007008BA
#define MOD_B2_HPF3_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.87526638791179)
#define MOD_B2_HPF3_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF3_ALG0_STAGE0_A2_ADDR                150
#define MOD_B2_HPF3_ALG0_STAGE0_A2_FIXPT               0xFF9E8B40
#define MOD_B2_HPF3_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.761375503464945)
#define MOD_B2_HPF3_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF3_ALG0_STAGE0_A1_ADDR                151
#define MOD_B2_HPF3_ALG0_STAGE0_A1_FIXPT               0x00DEAE29
#define MOD_B2_HPF3_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.73969004818222)
#define MOD_B2_HPF3_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_HPF3_ALG0_DATA_ADR_ADDR                 152
#define MOD_B2_HPF3_ALG0_DATA_ADR_FIXPT                0x00000143
#define MOD_B2_HPF3_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(323)
#define MOD_B2_HPF3_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF3_ALG0_DATAR_ADR_ADDR                153
#define MOD_B2_HPF3_ALG0_DATAR_ADR_FIXPT               0x0000014C
#define MOD_B2_HPF3_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(332)
#define MOD_B2_HPF3_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF3_ALG0_COEFF_ADR_ADDR                154
#define MOD_B2_HPF3_ALG0_COEFF_ADR_FIXPT               0x00000096
#define MOD_B2_HPF3_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(150)
#define MOD_B2_HPF3_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_HPF3_ALG0_LOOP_ADDR                     155
#define MOD_B2_HPF3_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_HPF3_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_HPF3_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_HPF3 - General (2nd order)*/
#define MOD_B3_HPF3_COUNT                              9
#define MOD_B3_HPF3_DEVICE                             "IC1"
#define MOD_B3_HPF3_ALG0_STAGE0_B2_ADDR                156
#define MOD_B3_HPF3_ALG0_STAGE0_B2_FIXPT               0x0048D628
#define MOD_B3_HPF3_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.569035593728849)
#define MOD_B3_HPF3_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF3_ALG0_STAGE0_B1_ADDR                157
#define MOD_B3_HPF3_ALG0_STAGE0_B1_FIXPT               0xFF6E53AF
#define MOD_B3_HPF3_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.1380711874577)
#define MOD_B3_HPF3_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF3_ALG0_STAGE0_B0_ADDR                158
#define MOD_B3_HPF3_ALG0_STAGE0_B0_FIXPT               0x0048D628
#define MOD_B3_HPF3_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.569035593728849)
#define MOD_B3_HPF3_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF3_ALG0_STAGE0_A2_ADDR                159
#define MOD_B3_HPF3_ALG0_STAGE0_A2_FIXPT               0xFFD55556
#define MOD_B3_HPF3_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.333333333333333)
#define MOD_B3_HPF3_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF3_ALG0_STAGE0_A1_ADDR                160
#define MOD_B3_HPF3_ALG0_STAGE0_A1_FIXPT               0x0078ADF7
#define MOD_B3_HPF3_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.942809041582063)
#define MOD_B3_HPF3_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_HPF3_ALG0_DATA_ADR_ADDR                 161
#define MOD_B3_HPF3_ALG0_DATA_ADR_FIXPT                0x00000157
#define MOD_B3_HPF3_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(343)
#define MOD_B3_HPF3_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF3_ALG0_DATAR_ADR_ADDR                162
#define MOD_B3_HPF3_ALG0_DATAR_ADR_FIXPT               0x00000160
#define MOD_B3_HPF3_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(352)
#define MOD_B3_HPF3_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF3_ALG0_COEFF_ADR_ADDR                163
#define MOD_B3_HPF3_ALG0_COEFF_ADR_FIXPT               0x0000009F
#define MOD_B3_HPF3_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(159)
#define MOD_B3_HPF3_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_HPF3_ALG0_LOOP_ADDR                     164
#define MOD_B3_HPF3_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_HPF3_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_HPF3_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_HPF3 - General (2nd order)*/
#define MOD_B1_HPF3_COUNT                              9
#define MOD_B1_HPF3_DEVICE                             "IC1"
#define MOD_B1_HPF3_ALG0_STAGE0_B2_ADDR                165
#define MOD_B1_HPF3_ALG0_STAGE0_B2_FIXPT               0x007F0E41
#define MOD_B1_HPF3_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.992622542756119)
#define MOD_B1_HPF3_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF3_ALG0_STAGE0_B1_ADDR                166
#define MOD_B1_HPF3_ALG0_STAGE0_B1_FIXPT               0xFF01E37E
#define MOD_B1_HPF3_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.98524508551224)
#define MOD_B1_HPF3_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF3_ALG0_STAGE0_B0_ADDR                167
#define MOD_B1_HPF3_ALG0_STAGE0_B0_FIXPT               0x007F0E41
#define MOD_B1_HPF3_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.992622542756119)
#define MOD_B1_HPF3_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF3_ALG0_STAGE0_A2_ADDR                168
#define MOD_B1_HPF3_ALG0_STAGE0_A2_FIXPT               0xFF81E1B5
#define MOD_B1_HPF3_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.985299513128215)
#define MOD_B1_HPF3_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF3_ALG0_STAGE0_A1_ADDR                169
#define MOD_B1_HPF3_ALG0_STAGE0_A1_FIXPT               0x00FE1ABA
#define MOD_B1_HPF3_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.98519065789626)
#define MOD_B1_HPF3_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_HPF3_ALG0_DATA_ADR_ADDR                 170
#define MOD_B1_HPF3_ALG0_DATA_ADR_FIXPT                0x0000016B
#define MOD_B1_HPF3_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(363)
#define MOD_B1_HPF3_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF3_ALG0_DATAR_ADR_ADDR                171
#define MOD_B1_HPF3_ALG0_DATAR_ADR_FIXPT               0x00000174
#define MOD_B1_HPF3_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(372)
#define MOD_B1_HPF3_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF3_ALG0_COEFF_ADR_ADDR                172
#define MOD_B1_HPF3_ALG0_COEFF_ADR_FIXPT               0x000000A8
#define MOD_B1_HPF3_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(168)
#define MOD_B1_HPF3_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_HPF3_ALG0_LOOP_ADDR                     173
#define MOD_B1_HPF3_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_HPF3_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_HPF3_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_HPF3 - General (2nd order)*/
#define MOD_B0_HPF3_COUNT                              9
#define MOD_B0_HPF3_DEVICE                             "IC1"
#define MOD_B0_HPF3_ALG0_STAGE0_B2_ADDR                174
#define MOD_B0_HPF3_ALG0_STAGE0_B2_FIXPT               0x007FE1AF
#define MOD_B0_HPF3_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.999074827623903)
#define MOD_B0_HPF3_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF3_ALG0_STAGE0_B1_ADDR                175
#define MOD_B0_HPF3_ALG0_STAGE0_B1_FIXPT               0xFF003CA2
#define MOD_B0_HPF3_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.99814965524781)
#define MOD_B0_HPF3_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF3_ALG0_STAGE0_B0_ADDR                176
#define MOD_B0_HPF3_ALG0_STAGE0_B0_FIXPT               0x007FE1AF
#define MOD_B0_HPF3_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.999074827623903)
#define MOD_B0_HPF3_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF3_ALG0_STAGE0_A2_ADDR                177
#define MOD_B0_HPF3_ALG0_STAGE0_A2_FIXPT               0xFF803C9B
#define MOD_B0_HPF3_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.998150511191915)
#define MOD_B0_HPF3_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF3_ALG0_STAGE0_A1_ADDR                178
#define MOD_B0_HPF3_ALG0_STAGE0_A1_FIXPT               0x00FFC357
#define MOD_B0_HPF3_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.9981487993037)
#define MOD_B0_HPF3_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_HPF3_ALG0_DATA_ADR_ADDR                 179
#define MOD_B0_HPF3_ALG0_DATA_ADR_FIXPT                0x0000017F
#define MOD_B0_HPF3_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(383)
#define MOD_B0_HPF3_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF3_ALG0_DATAR_ADR_ADDR                180
#define MOD_B0_HPF3_ALG0_DATAR_ADR_FIXPT               0x00000188
#define MOD_B0_HPF3_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(392)
#define MOD_B0_HPF3_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF3_ALG0_COEFF_ADR_ADDR                181
#define MOD_B0_HPF3_ALG0_COEFF_ADR_FIXPT               0x000000B1
#define MOD_B0_HPF3_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(177)
#define MOD_B0_HPF3_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_HPF3_ALG0_LOOP_ADDR                     182
#define MOD_B0_HPF3_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_HPF3_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_HPF3_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_LPF0 - General (2nd order)*/
#define MOD_B0_LPF0_COUNT                              9
#define MOD_B0_LPF0_DEVICE                             "IC1"
#define MOD_B0_LPF0_ALG0_STAGE0_B2_ADDR                183
#define MOD_B0_LPF0_ALG0_STAGE0_B2_FIXPT               0x000000E4
#define MOD_B0_LPF0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(2.72138079883189E-05)
#define MOD_B0_LPF0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF0_ALG0_STAGE0_B1_ADDR                184
#define MOD_B0_LPF0_ALG0_STAGE0_B1_FIXPT               0x000001C8
#define MOD_B0_LPF0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(5.44276159766377E-05)
#define MOD_B0_LPF0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF0_ALG0_STAGE0_B0_ADDR                185
#define MOD_B0_LPF0_ALG0_STAGE0_B0_FIXPT               0x000000E4
#define MOD_B0_LPF0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(2.72138079883189E-05)
#define MOD_B0_LPF0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF0_ALG0_STAGE0_A2_ADDR                186
#define MOD_B0_LPF0_ALG0_STAGE0_A2_FIXPT               0xFF81E1B5
#define MOD_B0_LPF0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.985299513128215)
#define MOD_B0_LPF0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF0_ALG0_STAGE0_A1_ADDR                187
#define MOD_B0_LPF0_ALG0_STAGE0_A1_FIXPT               0x00FE1ABA
#define MOD_B0_LPF0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.98519065789626)
#define MOD_B0_LPF0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF0_ALG0_DATA_ADR_ADDR                 188
#define MOD_B0_LPF0_ALG0_DATA_ADR_FIXPT                0x00000193
#define MOD_B0_LPF0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(403)
#define MOD_B0_LPF0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF0_ALG0_DATAR_ADR_ADDR                189
#define MOD_B0_LPF0_ALG0_DATAR_ADR_FIXPT               0x0000019C
#define MOD_B0_LPF0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(412)
#define MOD_B0_LPF0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF0_ALG0_COEFF_ADR_ADDR                190
#define MOD_B0_LPF0_ALG0_COEFF_ADR_FIXPT               0x000000BA
#define MOD_B0_LPF0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(186)
#define MOD_B0_LPF0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF0_ALG0_LOOP_ADDR                     191
#define MOD_B0_LPF0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_LPF0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_LPF0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_LPF0 - General (2nd order)*/
#define MOD_B1_LPF0_COUNT                              9
#define MOD_B1_LPF0_DEVICE                             "IC1"
#define MOD_B1_LPF0_ALG0_STAGE0_B2_ADDR                192
#define MOD_B1_LPF0_ALG0_STAGE0_B2_FIXPT               0x0000B59F
#define MOD_B1_LPF0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.00554271721028068)
#define MOD_B1_LPF0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF0_ALG0_STAGE0_B1_ADDR                193
#define MOD_B1_LPF0_ALG0_STAGE0_B1_FIXPT               0x00016B3F
#define MOD_B1_LPF0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0110854344205614)
#define MOD_B1_LPF0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF0_ALG0_STAGE0_B0_ADDR                194
#define MOD_B1_LPF0_ALG0_STAGE0_B0_FIXPT               0x0000B59F
#define MOD_B1_LPF0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.00554271721028068)
#define MOD_B1_LPF0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF0_ALG0_STAGE0_A2_ADDR                195
#define MOD_B1_LPF0_ALG0_STAGE0_A2_FIXPT               0xFF997F4D
#define MOD_B1_LPF0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.800802646665708)
#define MOD_B1_LPF0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF0_ALG0_STAGE0_A1_ADDR                196
#define MOD_B1_LPF0_ALG0_STAGE0_A1_FIXPT               0x00E3AA34
#define MOD_B1_LPF0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.77863177782459)
#define MOD_B1_LPF0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF0_ALG0_DATA_ADR_ADDR                 197
#define MOD_B1_LPF0_ALG0_DATA_ADR_FIXPT                0x000001A7
#define MOD_B1_LPF0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(423)
#define MOD_B1_LPF0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF0_ALG0_DATAR_ADR_ADDR                198
#define MOD_B1_LPF0_ALG0_DATAR_ADR_FIXPT               0x000001B0
#define MOD_B1_LPF0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(432)
#define MOD_B1_LPF0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF0_ALG0_COEFF_ADR_ADDR                199
#define MOD_B1_LPF0_ALG0_COEFF_ADR_FIXPT               0x000000C3
#define MOD_B1_LPF0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(195)
#define MOD_B1_LPF0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF0_ALG0_LOOP_ADDR                     200
#define MOD_B1_LPF0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_LPF0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_LPF0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_LPF0 - General (2nd order)*/
#define MOD_B2_LPF0_COUNT                              9
#define MOD_B2_LPF0_DEVICE                             "IC1"
#define MOD_B2_LPF0_ALG0_STAGE0_B2_ADDR                201
#define MOD_B2_LPF0_ALG0_STAGE0_B2_FIXPT               0x000C7F2C
#define MOD_B2_LPF0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0976310729378175)
#define MOD_B2_LPF0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF0_ALG0_STAGE0_B1_ADDR                202
#define MOD_B2_LPF0_ALG0_STAGE0_B1_FIXPT               0x0018FE59
#define MOD_B2_LPF0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.195262145875635)
#define MOD_B2_LPF0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF0_ALG0_STAGE0_B0_ADDR                203
#define MOD_B2_LPF0_ALG0_STAGE0_B0_FIXPT               0x000C7F2C
#define MOD_B2_LPF0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0976310729378175)
#define MOD_B2_LPF0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF0_ALG0_STAGE0_A2_ADDR                204
#define MOD_B2_LPF0_ALG0_STAGE0_A2_FIXPT               0xFFD55556
#define MOD_B2_LPF0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.333333333333333)
#define MOD_B2_LPF0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF0_ALG0_STAGE0_A1_ADDR                205
#define MOD_B2_LPF0_ALG0_STAGE0_A1_FIXPT               0x0078ADF7
#define MOD_B2_LPF0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.942809041582063)
#define MOD_B2_LPF0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF0_ALG0_DATA_ADR_ADDR                 206
#define MOD_B2_LPF0_ALG0_DATA_ADR_FIXPT                0x000001BB
#define MOD_B2_LPF0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(443)
#define MOD_B2_LPF0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF0_ALG0_DATAR_ADR_ADDR                207
#define MOD_B2_LPF0_ALG0_DATAR_ADR_FIXPT               0x000001C4
#define MOD_B2_LPF0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(452)
#define MOD_B2_LPF0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF0_ALG0_COEFF_ADR_ADDR                208
#define MOD_B2_LPF0_ALG0_COEFF_ADR_FIXPT               0x000000CC
#define MOD_B2_LPF0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(204)
#define MOD_B2_LPF0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF0_ALG0_LOOP_ADDR                     209
#define MOD_B2_LPF0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_LPF0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_LPF0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_LPF0 - General (2nd order)*/
#define MOD_B3_LPF0_COUNT                              9
#define MOD_B3_LPF0_DEVICE                             "IC1"
#define MOD_B3_LPF0_ALG0_STAGE0_B2_ADDR                210
#define MOD_B3_LPF0_ALG0_STAGE0_B2_FIXPT               0x00800000
#define MOD_B3_LPF0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_LPF0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF0_ALG0_STAGE0_B1_ADDR                211
#define MOD_B3_LPF0_ALG0_STAGE0_B1_FIXPT               0xFF6F4563
#define MOD_B3_LPF0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.13069506916105)
#define MOD_B3_LPF0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF0_ALG0_STAGE0_B0_ADDR                212
#define MOD_B3_LPF0_ALG0_STAGE0_B0_FIXPT               0x004CAD7B
#define MOD_B3_LPF0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.59904430171594)
#define MOD_B3_LPF0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF0_ALG0_STAGE0_A2_ADDR                213
#define MOD_B3_LPF0_ALG0_STAGE0_A2_FIXPT               0xFFB35285
#define MOD_B3_LPF0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.59904430171594)
#define MOD_B3_LPF0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF0_ALG0_STAGE0_A1_ADDR                214
#define MOD_B3_LPF0_ALG0_STAGE0_A1_FIXPT               0x0090BA9D
#define MOD_B3_LPF0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.13069506916105)
#define MOD_B3_LPF0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF0_ALG0_DATA_ADR_ADDR                 215
#define MOD_B3_LPF0_ALG0_DATA_ADR_FIXPT                0x000001CF
#define MOD_B3_LPF0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(463)
#define MOD_B3_LPF0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF0_ALG0_DATAR_ADR_ADDR                216
#define MOD_B3_LPF0_ALG0_DATAR_ADR_FIXPT               0x000001D8
#define MOD_B3_LPF0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(472)
#define MOD_B3_LPF0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF0_ALG0_COEFF_ADR_ADDR                217
#define MOD_B3_LPF0_ALG0_COEFF_ADR_FIXPT               0x000000D5
#define MOD_B3_LPF0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(213)
#define MOD_B3_LPF0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF0_ALG0_LOOP_ADDR                     218
#define MOD_B3_LPF0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_LPF0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_LPF0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_LPF1 - General (2nd order)*/
#define MOD_B2_LPF1_COUNT                              9
#define MOD_B2_LPF1_DEVICE                             "IC1"
#define MOD_B2_LPF1_ALG0_STAGE0_B2_ADDR                219
#define MOD_B2_LPF1_ALG0_STAGE0_B2_FIXPT               0x000C7F2C
#define MOD_B2_LPF1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0976310729378175)
#define MOD_B2_LPF1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF1_ALG0_STAGE0_B1_ADDR                220
#define MOD_B2_LPF1_ALG0_STAGE0_B1_FIXPT               0x0018FE59
#define MOD_B2_LPF1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.195262145875635)
#define MOD_B2_LPF1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF1_ALG0_STAGE0_B0_ADDR                221
#define MOD_B2_LPF1_ALG0_STAGE0_B0_FIXPT               0x000C7F2C
#define MOD_B2_LPF1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0976310729378175)
#define MOD_B2_LPF1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF1_ALG0_STAGE0_A2_ADDR                222
#define MOD_B2_LPF1_ALG0_STAGE0_A2_FIXPT               0xFFD55556
#define MOD_B2_LPF1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.333333333333333)
#define MOD_B2_LPF1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF1_ALG0_STAGE0_A1_ADDR                223
#define MOD_B2_LPF1_ALG0_STAGE0_A1_FIXPT               0x0078ADF7
#define MOD_B2_LPF1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.942809041582063)
#define MOD_B2_LPF1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF1_ALG0_DATA_ADR_ADDR                 224
#define MOD_B2_LPF1_ALG0_DATA_ADR_FIXPT                0x000001E3
#define MOD_B2_LPF1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(483)
#define MOD_B2_LPF1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF1_ALG0_DATAR_ADR_ADDR                225
#define MOD_B2_LPF1_ALG0_DATAR_ADR_FIXPT               0x000001EC
#define MOD_B2_LPF1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(492)
#define MOD_B2_LPF1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF1_ALG0_COEFF_ADR_ADDR                226
#define MOD_B2_LPF1_ALG0_COEFF_ADR_FIXPT               0x000000DE
#define MOD_B2_LPF1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(222)
#define MOD_B2_LPF1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF1_ALG0_LOOP_ADDR                     227
#define MOD_B2_LPF1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_LPF1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_LPF1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_LPF1 - General (2nd order)*/
#define MOD_B3_LPF1_COUNT                              9
#define MOD_B3_LPF1_DEVICE                             "IC1"
#define MOD_B3_LPF1_ALG0_STAGE0_B2_ADDR                228
#define MOD_B3_LPF1_ALG0_STAGE0_B2_FIXPT               0x00800000
#define MOD_B3_LPF1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_LPF1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF1_ALG0_STAGE0_B1_ADDR                229
#define MOD_B3_LPF1_ALG0_STAGE0_B1_FIXPT               0xFF6F4563
#define MOD_B3_LPF1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.13069506916105)
#define MOD_B3_LPF1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF1_ALG0_STAGE0_B0_ADDR                230
#define MOD_B3_LPF1_ALG0_STAGE0_B0_FIXPT               0x004CAD7B
#define MOD_B3_LPF1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.59904430171594)
#define MOD_B3_LPF1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF1_ALG0_STAGE0_A2_ADDR                231
#define MOD_B3_LPF1_ALG0_STAGE0_A2_FIXPT               0xFFB35285
#define MOD_B3_LPF1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.59904430171594)
#define MOD_B3_LPF1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF1_ALG0_STAGE0_A1_ADDR                232
#define MOD_B3_LPF1_ALG0_STAGE0_A1_FIXPT               0x0090BA9D
#define MOD_B3_LPF1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.13069506916105)
#define MOD_B3_LPF1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF1_ALG0_DATA_ADR_ADDR                 233
#define MOD_B3_LPF1_ALG0_DATA_ADR_FIXPT                0x000001F7
#define MOD_B3_LPF1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(503)
#define MOD_B3_LPF1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF1_ALG0_DATAR_ADR_ADDR                234
#define MOD_B3_LPF1_ALG0_DATAR_ADR_FIXPT               0x00000200
#define MOD_B3_LPF1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(512)
#define MOD_B3_LPF1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF1_ALG0_COEFF_ADR_ADDR                235
#define MOD_B3_LPF1_ALG0_COEFF_ADR_FIXPT               0x000000E7
#define MOD_B3_LPF1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(231)
#define MOD_B3_LPF1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF1_ALG0_LOOP_ADDR                     236
#define MOD_B3_LPF1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_LPF1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_LPF1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_LPF1 - General (2nd order)*/
#define MOD_B1_LPF1_COUNT                              9
#define MOD_B1_LPF1_DEVICE                             "IC1"
#define MOD_B1_LPF1_ALG0_STAGE0_B2_ADDR                237
#define MOD_B1_LPF1_ALG0_STAGE0_B2_FIXPT               0x0000B59F
#define MOD_B1_LPF1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.00554271721028068)
#define MOD_B1_LPF1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF1_ALG0_STAGE0_B1_ADDR                238
#define MOD_B1_LPF1_ALG0_STAGE0_B1_FIXPT               0x00016B3F
#define MOD_B1_LPF1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0110854344205614)
#define MOD_B1_LPF1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF1_ALG0_STAGE0_B0_ADDR                239
#define MOD_B1_LPF1_ALG0_STAGE0_B0_FIXPT               0x0000B59F
#define MOD_B1_LPF1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.00554271721028068)
#define MOD_B1_LPF1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF1_ALG0_STAGE0_A2_ADDR                240
#define MOD_B1_LPF1_ALG0_STAGE0_A2_FIXPT               0xFF997F4D
#define MOD_B1_LPF1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.800802646665708)
#define MOD_B1_LPF1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF1_ALG0_STAGE0_A1_ADDR                241
#define MOD_B1_LPF1_ALG0_STAGE0_A1_FIXPT               0x00E3AA34
#define MOD_B1_LPF1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.77863177782459)
#define MOD_B1_LPF1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF1_ALG0_DATA_ADR_ADDR                 242
#define MOD_B1_LPF1_ALG0_DATA_ADR_FIXPT                0x0000020B
#define MOD_B1_LPF1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(523)
#define MOD_B1_LPF1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF1_ALG0_DATAR_ADR_ADDR                243
#define MOD_B1_LPF1_ALG0_DATAR_ADR_FIXPT               0x00000214
#define MOD_B1_LPF1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(532)
#define MOD_B1_LPF1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF1_ALG0_COEFF_ADR_ADDR                244
#define MOD_B1_LPF1_ALG0_COEFF_ADR_FIXPT               0x000000F0
#define MOD_B1_LPF1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(240)
#define MOD_B1_LPF1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF1_ALG0_LOOP_ADDR                     245
#define MOD_B1_LPF1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_LPF1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_LPF1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_LPF1 - General (2nd order)*/
#define MOD_B0_LPF1_COUNT                              9
#define MOD_B0_LPF1_DEVICE                             "IC1"
#define MOD_B0_LPF1_ALG0_STAGE0_B2_ADDR                246
#define MOD_B0_LPF1_ALG0_STAGE0_B2_FIXPT               0x000000E4
#define MOD_B0_LPF1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(2.72138079883189E-05)
#define MOD_B0_LPF1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF1_ALG0_STAGE0_B1_ADDR                247
#define MOD_B0_LPF1_ALG0_STAGE0_B1_FIXPT               0x000001C8
#define MOD_B0_LPF1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(5.44276159766377E-05)
#define MOD_B0_LPF1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF1_ALG0_STAGE0_B0_ADDR                248
#define MOD_B0_LPF1_ALG0_STAGE0_B0_FIXPT               0x000000E4
#define MOD_B0_LPF1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(2.72138079883189E-05)
#define MOD_B0_LPF1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF1_ALG0_STAGE0_A2_ADDR                249
#define MOD_B0_LPF1_ALG0_STAGE0_A2_FIXPT               0xFF81E1B5
#define MOD_B0_LPF1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.985299513128215)
#define MOD_B0_LPF1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF1_ALG0_STAGE0_A1_ADDR                250
#define MOD_B0_LPF1_ALG0_STAGE0_A1_FIXPT               0x00FE1ABA
#define MOD_B0_LPF1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.98519065789626)
#define MOD_B0_LPF1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF1_ALG0_DATA_ADR_ADDR                 251
#define MOD_B0_LPF1_ALG0_DATA_ADR_FIXPT                0x0000021F
#define MOD_B0_LPF1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(543)
#define MOD_B0_LPF1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF1_ALG0_DATAR_ADR_ADDR                252
#define MOD_B0_LPF1_ALG0_DATAR_ADR_FIXPT               0x00000228
#define MOD_B0_LPF1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(552)
#define MOD_B0_LPF1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF1_ALG0_COEFF_ADR_ADDR                253
#define MOD_B0_LPF1_ALG0_COEFF_ADR_FIXPT               0x000000F9
#define MOD_B0_LPF1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(249)
#define MOD_B0_LPF1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF1_ALG0_LOOP_ADDR                     254
#define MOD_B0_LPF1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_LPF1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_LPF1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_LPF2 - General (2nd order)*/
#define MOD_B3_LPF2_COUNT                              9
#define MOD_B3_LPF2_DEVICE                             "IC1"
#define MOD_B3_LPF2_ALG0_STAGE0_B2_ADDR                255
#define MOD_B3_LPF2_ALG0_STAGE0_B2_FIXPT               0x00800000
#define MOD_B3_LPF2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_LPF2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF2_ALG0_STAGE0_B1_ADDR                256
#define MOD_B3_LPF2_ALG0_STAGE0_B1_FIXPT               0xFF6F4563
#define MOD_B3_LPF2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.13069506916105)
#define MOD_B3_LPF2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF2_ALG0_STAGE0_B0_ADDR                257
#define MOD_B3_LPF2_ALG0_STAGE0_B0_FIXPT               0x004CAD7B
#define MOD_B3_LPF2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.59904430171594)
#define MOD_B3_LPF2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF2_ALG0_STAGE0_A2_ADDR                258
#define MOD_B3_LPF2_ALG0_STAGE0_A2_FIXPT               0xFFB35285
#define MOD_B3_LPF2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.59904430171594)
#define MOD_B3_LPF2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF2_ALG0_STAGE0_A1_ADDR                259
#define MOD_B3_LPF2_ALG0_STAGE0_A1_FIXPT               0x0090BA9D
#define MOD_B3_LPF2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.13069506916105)
#define MOD_B3_LPF2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF2_ALG0_DATA_ADR_ADDR                 260
#define MOD_B3_LPF2_ALG0_DATA_ADR_FIXPT                0x00000233
#define MOD_B3_LPF2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(563)
#define MOD_B3_LPF2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF2_ALG0_DATAR_ADR_ADDR                261
#define MOD_B3_LPF2_ALG0_DATAR_ADR_FIXPT               0x0000023C
#define MOD_B3_LPF2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(572)
#define MOD_B3_LPF2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF2_ALG0_COEFF_ADR_ADDR                262
#define MOD_B3_LPF2_ALG0_COEFF_ADR_FIXPT               0x00000102
#define MOD_B3_LPF2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(258)
#define MOD_B3_LPF2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF2_ALG0_LOOP_ADDR                     263
#define MOD_B3_LPF2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_LPF2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_LPF2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_LPF2 - General (2nd order)*/
#define MOD_B2_LPF2_COUNT                              9
#define MOD_B2_LPF2_DEVICE                             "IC1"
#define MOD_B2_LPF2_ALG0_STAGE0_B2_ADDR                264
#define MOD_B2_LPF2_ALG0_STAGE0_B2_FIXPT               0x000C7F2C
#define MOD_B2_LPF2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0976310729378175)
#define MOD_B2_LPF2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF2_ALG0_STAGE0_B1_ADDR                265
#define MOD_B2_LPF2_ALG0_STAGE0_B1_FIXPT               0x0018FE59
#define MOD_B2_LPF2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.195262145875635)
#define MOD_B2_LPF2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF2_ALG0_STAGE0_B0_ADDR                266
#define MOD_B2_LPF2_ALG0_STAGE0_B0_FIXPT               0x000C7F2C
#define MOD_B2_LPF2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0976310729378175)
#define MOD_B2_LPF2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF2_ALG0_STAGE0_A2_ADDR                267
#define MOD_B2_LPF2_ALG0_STAGE0_A2_FIXPT               0xFFD55556
#define MOD_B2_LPF2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.333333333333333)
#define MOD_B2_LPF2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF2_ALG0_STAGE0_A1_ADDR                268
#define MOD_B2_LPF2_ALG0_STAGE0_A1_FIXPT               0x0078ADF7
#define MOD_B2_LPF2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.942809041582063)
#define MOD_B2_LPF2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF2_ALG0_DATA_ADR_ADDR                 269
#define MOD_B2_LPF2_ALG0_DATA_ADR_FIXPT                0x00000247
#define MOD_B2_LPF2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(583)
#define MOD_B2_LPF2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF2_ALG0_DATAR_ADR_ADDR                270
#define MOD_B2_LPF2_ALG0_DATAR_ADR_FIXPT               0x00000250
#define MOD_B2_LPF2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(592)
#define MOD_B2_LPF2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF2_ALG0_COEFF_ADR_ADDR                271
#define MOD_B2_LPF2_ALG0_COEFF_ADR_FIXPT               0x0000010B
#define MOD_B2_LPF2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(267)
#define MOD_B2_LPF2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF2_ALG0_LOOP_ADDR                     272
#define MOD_B2_LPF2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_LPF2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_LPF2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_LPF2 - General (2nd order)*/
#define MOD_B0_LPF2_COUNT                              9
#define MOD_B0_LPF2_DEVICE                             "IC1"
#define MOD_B0_LPF2_ALG0_STAGE0_B2_ADDR                273
#define MOD_B0_LPF2_ALG0_STAGE0_B2_FIXPT               0x000000E4
#define MOD_B0_LPF2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(2.72138079883189E-05)
#define MOD_B0_LPF2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF2_ALG0_STAGE0_B1_ADDR                274
#define MOD_B0_LPF2_ALG0_STAGE0_B1_FIXPT               0x000001C8
#define MOD_B0_LPF2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(5.44276159766377E-05)
#define MOD_B0_LPF2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF2_ALG0_STAGE0_B0_ADDR                275
#define MOD_B0_LPF2_ALG0_STAGE0_B0_FIXPT               0x000000E4
#define MOD_B0_LPF2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(2.72138079883189E-05)
#define MOD_B0_LPF2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF2_ALG0_STAGE0_A2_ADDR                276
#define MOD_B0_LPF2_ALG0_STAGE0_A2_FIXPT               0xFF81E1B5
#define MOD_B0_LPF2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.985299513128215)
#define MOD_B0_LPF2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF2_ALG0_STAGE0_A1_ADDR                277
#define MOD_B0_LPF2_ALG0_STAGE0_A1_FIXPT               0x00FE1ABA
#define MOD_B0_LPF2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.98519065789626)
#define MOD_B0_LPF2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF2_ALG0_DATA_ADR_ADDR                 278
#define MOD_B0_LPF2_ALG0_DATA_ADR_FIXPT                0x0000025B
#define MOD_B0_LPF2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(603)
#define MOD_B0_LPF2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF2_ALG0_DATAR_ADR_ADDR                279
#define MOD_B0_LPF2_ALG0_DATAR_ADR_FIXPT               0x00000264
#define MOD_B0_LPF2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(612)
#define MOD_B0_LPF2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF2_ALG0_COEFF_ADR_ADDR                280
#define MOD_B0_LPF2_ALG0_COEFF_ADR_FIXPT               0x00000114
#define MOD_B0_LPF2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(276)
#define MOD_B0_LPF2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF2_ALG0_LOOP_ADDR                     281
#define MOD_B0_LPF2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_LPF2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_LPF2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_LPF2 - General (2nd order)*/
#define MOD_B1_LPF2_COUNT                              9
#define MOD_B1_LPF2_DEVICE                             "IC1"
#define MOD_B1_LPF2_ALG0_STAGE0_B2_ADDR                282
#define MOD_B1_LPF2_ALG0_STAGE0_B2_FIXPT               0x0000B59F
#define MOD_B1_LPF2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.00554271721028068)
#define MOD_B1_LPF2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF2_ALG0_STAGE0_B1_ADDR                283
#define MOD_B1_LPF2_ALG0_STAGE0_B1_FIXPT               0x00016B3F
#define MOD_B1_LPF2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0110854344205614)
#define MOD_B1_LPF2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF2_ALG0_STAGE0_B0_ADDR                284
#define MOD_B1_LPF2_ALG0_STAGE0_B0_FIXPT               0x0000B59F
#define MOD_B1_LPF2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.00554271721028068)
#define MOD_B1_LPF2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF2_ALG0_STAGE0_A2_ADDR                285
#define MOD_B1_LPF2_ALG0_STAGE0_A2_FIXPT               0xFF997F4D
#define MOD_B1_LPF2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.800802646665708)
#define MOD_B1_LPF2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF2_ALG0_STAGE0_A1_ADDR                286
#define MOD_B1_LPF2_ALG0_STAGE0_A1_FIXPT               0x00E3AA34
#define MOD_B1_LPF2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.77863177782459)
#define MOD_B1_LPF2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF2_ALG0_DATA_ADR_ADDR                 287
#define MOD_B1_LPF2_ALG0_DATA_ADR_FIXPT                0x0000026F
#define MOD_B1_LPF2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(623)
#define MOD_B1_LPF2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF2_ALG0_DATAR_ADR_ADDR                288
#define MOD_B1_LPF2_ALG0_DATAR_ADR_FIXPT               0x00000278
#define MOD_B1_LPF2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(632)
#define MOD_B1_LPF2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF2_ALG0_COEFF_ADR_ADDR                289
#define MOD_B1_LPF2_ALG0_COEFF_ADR_FIXPT               0x0000011D
#define MOD_B1_LPF2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(285)
#define MOD_B1_LPF2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF2_ALG0_LOOP_ADDR                     290
#define MOD_B1_LPF2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_LPF2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_LPF2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_LPF3 - General (2nd order)*/
#define MOD_B2_LPF3_COUNT                              9
#define MOD_B2_LPF3_DEVICE                             "IC1"
#define MOD_B2_LPF3_ALG0_STAGE0_B2_ADDR                291
#define MOD_B2_LPF3_ALG0_STAGE0_B2_FIXPT               0x000C7F2C
#define MOD_B2_LPF3_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0976310729378175)
#define MOD_B2_LPF3_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF3_ALG0_STAGE0_B1_ADDR                292
#define MOD_B2_LPF3_ALG0_STAGE0_B1_FIXPT               0x0018FE59
#define MOD_B2_LPF3_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.195262145875635)
#define MOD_B2_LPF3_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF3_ALG0_STAGE0_B0_ADDR                293
#define MOD_B2_LPF3_ALG0_STAGE0_B0_FIXPT               0x000C7F2C
#define MOD_B2_LPF3_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0976310729378175)
#define MOD_B2_LPF3_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF3_ALG0_STAGE0_A2_ADDR                294
#define MOD_B2_LPF3_ALG0_STAGE0_A2_FIXPT               0xFFD55556
#define MOD_B2_LPF3_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.333333333333333)
#define MOD_B2_LPF3_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF3_ALG0_STAGE0_A1_ADDR                295
#define MOD_B2_LPF3_ALG0_STAGE0_A1_FIXPT               0x0078ADF7
#define MOD_B2_LPF3_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.942809041582063)
#define MOD_B2_LPF3_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_LPF3_ALG0_DATA_ADR_ADDR                 296
#define MOD_B2_LPF3_ALG0_DATA_ADR_FIXPT                0x00000283
#define MOD_B2_LPF3_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(643)
#define MOD_B2_LPF3_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF3_ALG0_DATAR_ADR_ADDR                297
#define MOD_B2_LPF3_ALG0_DATAR_ADR_FIXPT               0x0000028C
#define MOD_B2_LPF3_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(652)
#define MOD_B2_LPF3_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF3_ALG0_COEFF_ADR_ADDR                298
#define MOD_B2_LPF3_ALG0_COEFF_ADR_FIXPT               0x00000126
#define MOD_B2_LPF3_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(294)
#define MOD_B2_LPF3_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_LPF3_ALG0_LOOP_ADDR                     299
#define MOD_B2_LPF3_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_LPF3_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_LPF3_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_LPF3 - General (2nd order)*/
#define MOD_B0_LPF3_COUNT                              9
#define MOD_B0_LPF3_DEVICE                             "IC1"
#define MOD_B0_LPF3_ALG0_STAGE0_B2_ADDR                300
#define MOD_B0_LPF3_ALG0_STAGE0_B2_FIXPT               0x000000E4
#define MOD_B0_LPF3_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(2.72138079883189E-05)
#define MOD_B0_LPF3_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF3_ALG0_STAGE0_B1_ADDR                301
#define MOD_B0_LPF3_ALG0_STAGE0_B1_FIXPT               0x000001C8
#define MOD_B0_LPF3_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(5.44276159766377E-05)
#define MOD_B0_LPF3_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF3_ALG0_STAGE0_B0_ADDR                302
#define MOD_B0_LPF3_ALG0_STAGE0_B0_FIXPT               0x000000E4
#define MOD_B0_LPF3_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(2.72138079883189E-05)
#define MOD_B0_LPF3_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF3_ALG0_STAGE0_A2_ADDR                303
#define MOD_B0_LPF3_ALG0_STAGE0_A2_FIXPT               0xFF81E1B5
#define MOD_B0_LPF3_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.985299513128215)
#define MOD_B0_LPF3_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF3_ALG0_STAGE0_A1_ADDR                304
#define MOD_B0_LPF3_ALG0_STAGE0_A1_FIXPT               0x00FE1ABA
#define MOD_B0_LPF3_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.98519065789626)
#define MOD_B0_LPF3_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_LPF3_ALG0_DATA_ADR_ADDR                 305
#define MOD_B0_LPF3_ALG0_DATA_ADR_FIXPT                0x00000297
#define MOD_B0_LPF3_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(663)
#define MOD_B0_LPF3_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF3_ALG0_DATAR_ADR_ADDR                306
#define MOD_B0_LPF3_ALG0_DATAR_ADR_FIXPT               0x000002A0
#define MOD_B0_LPF3_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(672)
#define MOD_B0_LPF3_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF3_ALG0_COEFF_ADR_ADDR                307
#define MOD_B0_LPF3_ALG0_COEFF_ADR_FIXPT               0x0000012F
#define MOD_B0_LPF3_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(303)
#define MOD_B0_LPF3_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_LPF3_ALG0_LOOP_ADDR                     308
#define MOD_B0_LPF3_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_LPF3_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_LPF3_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_LPF3 - General (2nd order)*/
#define MOD_B1_LPF3_COUNT                              9
#define MOD_B1_LPF3_DEVICE                             "IC1"
#define MOD_B1_LPF3_ALG0_STAGE0_B2_ADDR                309
#define MOD_B1_LPF3_ALG0_STAGE0_B2_FIXPT               0x0000B59F
#define MOD_B1_LPF3_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.00554271721028068)
#define MOD_B1_LPF3_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF3_ALG0_STAGE0_B1_ADDR                310
#define MOD_B1_LPF3_ALG0_STAGE0_B1_FIXPT               0x00016B3F
#define MOD_B1_LPF3_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0110854344205614)
#define MOD_B1_LPF3_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF3_ALG0_STAGE0_B0_ADDR                311
#define MOD_B1_LPF3_ALG0_STAGE0_B0_FIXPT               0x0000B59F
#define MOD_B1_LPF3_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.00554271721028068)
#define MOD_B1_LPF3_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF3_ALG0_STAGE0_A2_ADDR                312
#define MOD_B1_LPF3_ALG0_STAGE0_A2_FIXPT               0xFF997F4D
#define MOD_B1_LPF3_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.800802646665708)
#define MOD_B1_LPF3_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF3_ALG0_STAGE0_A1_ADDR                313
#define MOD_B1_LPF3_ALG0_STAGE0_A1_FIXPT               0x00E3AA34
#define MOD_B1_LPF3_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.77863177782459)
#define MOD_B1_LPF3_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_LPF3_ALG0_DATA_ADR_ADDR                 314
#define MOD_B1_LPF3_ALG0_DATA_ADR_FIXPT                0x000002AB
#define MOD_B1_LPF3_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(683)
#define MOD_B1_LPF3_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF3_ALG0_DATAR_ADR_ADDR                315
#define MOD_B1_LPF3_ALG0_DATAR_ADR_FIXPT               0x000002B4
#define MOD_B1_LPF3_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(692)
#define MOD_B1_LPF3_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF3_ALG0_COEFF_ADR_ADDR                316
#define MOD_B1_LPF3_ALG0_COEFF_ADR_FIXPT               0x00000138
#define MOD_B1_LPF3_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(312)
#define MOD_B1_LPF3_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_LPF3_ALG0_LOOP_ADDR                     317
#define MOD_B1_LPF3_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_LPF3_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_LPF3_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_LPF3 - General (2nd order)*/
#define MOD_B3_LPF3_COUNT                              9
#define MOD_B3_LPF3_DEVICE                             "IC1"
#define MOD_B3_LPF3_ALG0_STAGE0_B2_ADDR                318
#define MOD_B3_LPF3_ALG0_STAGE0_B2_FIXPT               0x00800000
#define MOD_B3_LPF3_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_LPF3_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF3_ALG0_STAGE0_B1_ADDR                319
#define MOD_B3_LPF3_ALG0_STAGE0_B1_FIXPT               0xFF6F4563
#define MOD_B3_LPF3_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-1.13069506916105)
#define MOD_B3_LPF3_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF3_ALG0_STAGE0_B0_ADDR                320
#define MOD_B3_LPF3_ALG0_STAGE0_B0_FIXPT               0x004CAD7B
#define MOD_B3_LPF3_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.59904430171594)
#define MOD_B3_LPF3_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF3_ALG0_STAGE0_A2_ADDR                321
#define MOD_B3_LPF3_ALG0_STAGE0_A2_FIXPT               0xFFB35285
#define MOD_B3_LPF3_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(-0.59904430171594)
#define MOD_B3_LPF3_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF3_ALG0_STAGE0_A1_ADDR                322
#define MOD_B3_LPF3_ALG0_STAGE0_A1_FIXPT               0x0090BA9D
#define MOD_B3_LPF3_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1.13069506916105)
#define MOD_B3_LPF3_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_LPF3_ALG0_DATA_ADR_ADDR                 323
#define MOD_B3_LPF3_ALG0_DATA_ADR_FIXPT                0x000002BF
#define MOD_B3_LPF3_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(703)
#define MOD_B3_LPF3_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF3_ALG0_DATAR_ADR_ADDR                324
#define MOD_B3_LPF3_ALG0_DATAR_ADR_FIXPT               0x000002C8
#define MOD_B3_LPF3_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(712)
#define MOD_B3_LPF3_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF3_ALG0_COEFF_ADR_ADDR                325
#define MOD_B3_LPF3_ALG0_COEFF_ADR_FIXPT               0x00000141
#define MOD_B3_LPF3_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(321)
#define MOD_B3_LPF3_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_LPF3_ALG0_LOOP_ADDR                     326
#define MOD_B3_LPF3_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_LPF3_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_LPF3_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_GEN0 - General (2nd order)*/
#define MOD_B3_GEN0_COUNT                              9
#define MOD_B3_GEN0_DEVICE                             "IC1"
#define MOD_B3_GEN0_ALG0_STAGE0_B2_ADDR                327
#define MOD_B3_GEN0_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B3_GEN0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN0_ALG0_STAGE0_B1_ADDR                328
#define MOD_B3_GEN0_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B3_GEN0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN0_ALG0_STAGE0_B0_ADDR                329
#define MOD_B3_GEN0_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B3_GEN0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_GEN0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN0_ALG0_STAGE0_A2_ADDR                330
#define MOD_B3_GEN0_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B3_GEN0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN0_ALG0_STAGE0_A1_ADDR                331
#define MOD_B3_GEN0_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B3_GEN0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN0_ALG0_DATA_ADR_ADDR                 332
#define MOD_B3_GEN0_ALG0_DATA_ADR_FIXPT                0x000002D3
#define MOD_B3_GEN0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(723)
#define MOD_B3_GEN0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN0_ALG0_DATAR_ADR_ADDR                333
#define MOD_B3_GEN0_ALG0_DATAR_ADR_FIXPT               0x000002DC
#define MOD_B3_GEN0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(732)
#define MOD_B3_GEN0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN0_ALG0_COEFF_ADR_ADDR                334
#define MOD_B3_GEN0_ALG0_COEFF_ADR_FIXPT               0x0000014A
#define MOD_B3_GEN0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(330)
#define MOD_B3_GEN0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN0_ALG0_LOOP_ADDR                     335
#define MOD_B3_GEN0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_GEN0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_GEN0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_GEN0 - General (2nd order)*/
#define MOD_B2_GEN0_COUNT                              9
#define MOD_B2_GEN0_DEVICE                             "IC1"
#define MOD_B2_GEN0_ALG0_STAGE0_B2_ADDR                336
#define MOD_B2_GEN0_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B2_GEN0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN0_ALG0_STAGE0_B1_ADDR                337
#define MOD_B2_GEN0_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B2_GEN0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN0_ALG0_STAGE0_B0_ADDR                338
#define MOD_B2_GEN0_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B2_GEN0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B2_GEN0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN0_ALG0_STAGE0_A2_ADDR                339
#define MOD_B2_GEN0_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B2_GEN0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN0_ALG0_STAGE0_A1_ADDR                340
#define MOD_B2_GEN0_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B2_GEN0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN0_ALG0_DATA_ADR_ADDR                 341
#define MOD_B2_GEN0_ALG0_DATA_ADR_FIXPT                0x000002E7
#define MOD_B2_GEN0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(743)
#define MOD_B2_GEN0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN0_ALG0_DATAR_ADR_ADDR                342
#define MOD_B2_GEN0_ALG0_DATAR_ADR_FIXPT               0x000002F0
#define MOD_B2_GEN0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(752)
#define MOD_B2_GEN0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN0_ALG0_COEFF_ADR_ADDR                343
#define MOD_B2_GEN0_ALG0_COEFF_ADR_FIXPT               0x00000153
#define MOD_B2_GEN0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(339)
#define MOD_B2_GEN0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN0_ALG0_LOOP_ADDR                     344
#define MOD_B2_GEN0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_GEN0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_GEN0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_GEN0 - General (2nd order)*/
#define MOD_B1_GEN0_COUNT                              9
#define MOD_B1_GEN0_DEVICE                             "IC1"
#define MOD_B1_GEN0_ALG0_STAGE0_B2_ADDR                345
#define MOD_B1_GEN0_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B1_GEN0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN0_ALG0_STAGE0_B1_ADDR                346
#define MOD_B1_GEN0_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B1_GEN0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN0_ALG0_STAGE0_B0_ADDR                347
#define MOD_B1_GEN0_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B1_GEN0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B1_GEN0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN0_ALG0_STAGE0_A2_ADDR                348
#define MOD_B1_GEN0_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B1_GEN0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN0_ALG0_STAGE0_A1_ADDR                349
#define MOD_B1_GEN0_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B1_GEN0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN0_ALG0_DATA_ADR_ADDR                 350
#define MOD_B1_GEN0_ALG0_DATA_ADR_FIXPT                0x000002FB
#define MOD_B1_GEN0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(763)
#define MOD_B1_GEN0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN0_ALG0_DATAR_ADR_ADDR                351
#define MOD_B1_GEN0_ALG0_DATAR_ADR_FIXPT               0x00000304
#define MOD_B1_GEN0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(772)
#define MOD_B1_GEN0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN0_ALG0_COEFF_ADR_ADDR                352
#define MOD_B1_GEN0_ALG0_COEFF_ADR_FIXPT               0x0000015C
#define MOD_B1_GEN0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(348)
#define MOD_B1_GEN0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN0_ALG0_LOOP_ADDR                     353
#define MOD_B1_GEN0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_GEN0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_GEN0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_GEN0 - General (2nd order)*/
#define MOD_B0_GEN0_COUNT                              9
#define MOD_B0_GEN0_DEVICE                             "IC1"
#define MOD_B0_GEN0_ALG0_STAGE0_B2_ADDR                354
#define MOD_B0_GEN0_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B0_GEN0_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN0_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN0_ALG0_STAGE0_B1_ADDR                355
#define MOD_B0_GEN0_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B0_GEN0_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN0_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN0_ALG0_STAGE0_B0_ADDR                356
#define MOD_B0_GEN0_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B0_GEN0_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B0_GEN0_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN0_ALG0_STAGE0_A2_ADDR                357
#define MOD_B0_GEN0_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B0_GEN0_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN0_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN0_ALG0_STAGE0_A1_ADDR                358
#define MOD_B0_GEN0_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B0_GEN0_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN0_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN0_ALG0_DATA_ADR_ADDR                 359
#define MOD_B0_GEN0_ALG0_DATA_ADR_FIXPT                0x0000030F
#define MOD_B0_GEN0_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(783)
#define MOD_B0_GEN0_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN0_ALG0_DATAR_ADR_ADDR                360
#define MOD_B0_GEN0_ALG0_DATAR_ADR_FIXPT               0x00000318
#define MOD_B0_GEN0_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(792)
#define MOD_B0_GEN0_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN0_ALG0_COEFF_ADR_ADDR                361
#define MOD_B0_GEN0_ALG0_COEFF_ADR_FIXPT               0x00000165
#define MOD_B0_GEN0_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(357)
#define MOD_B0_GEN0_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN0_ALG0_LOOP_ADDR                     362
#define MOD_B0_GEN0_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_GEN0_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_GEN0_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_GEN1 - General (2nd order)*/
#define MOD_B0_GEN1_COUNT                              9
#define MOD_B0_GEN1_DEVICE                             "IC1"
#define MOD_B0_GEN1_ALG0_STAGE0_B2_ADDR                363
#define MOD_B0_GEN1_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B0_GEN1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN1_ALG0_STAGE0_B1_ADDR                364
#define MOD_B0_GEN1_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B0_GEN1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN1_ALG0_STAGE0_B0_ADDR                365
#define MOD_B0_GEN1_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B0_GEN1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B0_GEN1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN1_ALG0_STAGE0_A2_ADDR                366
#define MOD_B0_GEN1_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B0_GEN1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN1_ALG0_STAGE0_A1_ADDR                367
#define MOD_B0_GEN1_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B0_GEN1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN1_ALG0_DATA_ADR_ADDR                 368
#define MOD_B0_GEN1_ALG0_DATA_ADR_FIXPT                0x00000323
#define MOD_B0_GEN1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(803)
#define MOD_B0_GEN1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN1_ALG0_DATAR_ADR_ADDR                369
#define MOD_B0_GEN1_ALG0_DATAR_ADR_FIXPT               0x0000032C
#define MOD_B0_GEN1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(812)
#define MOD_B0_GEN1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN1_ALG0_COEFF_ADR_ADDR                370
#define MOD_B0_GEN1_ALG0_COEFF_ADR_FIXPT               0x0000016E
#define MOD_B0_GEN1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(366)
#define MOD_B0_GEN1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN1_ALG0_LOOP_ADDR                     371
#define MOD_B0_GEN1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_GEN1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_GEN1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_GEN1 - General (2nd order)*/
#define MOD_B1_GEN1_COUNT                              9
#define MOD_B1_GEN1_DEVICE                             "IC1"
#define MOD_B1_GEN1_ALG0_STAGE0_B2_ADDR                372
#define MOD_B1_GEN1_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B1_GEN1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN1_ALG0_STAGE0_B1_ADDR                373
#define MOD_B1_GEN1_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B1_GEN1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN1_ALG0_STAGE0_B0_ADDR                374
#define MOD_B1_GEN1_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B1_GEN1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B1_GEN1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN1_ALG0_STAGE0_A2_ADDR                375
#define MOD_B1_GEN1_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B1_GEN1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN1_ALG0_STAGE0_A1_ADDR                376
#define MOD_B1_GEN1_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B1_GEN1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN1_ALG0_DATA_ADR_ADDR                 377
#define MOD_B1_GEN1_ALG0_DATA_ADR_FIXPT                0x00000337
#define MOD_B1_GEN1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(823)
#define MOD_B1_GEN1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN1_ALG0_DATAR_ADR_ADDR                378
#define MOD_B1_GEN1_ALG0_DATAR_ADR_FIXPT               0x00000340
#define MOD_B1_GEN1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(832)
#define MOD_B1_GEN1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN1_ALG0_COEFF_ADR_ADDR                379
#define MOD_B1_GEN1_ALG0_COEFF_ADR_FIXPT               0x00000177
#define MOD_B1_GEN1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(375)
#define MOD_B1_GEN1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN1_ALG0_LOOP_ADDR                     380
#define MOD_B1_GEN1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_GEN1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_GEN1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_GEN1 - General (2nd order)*/
#define MOD_B2_GEN1_COUNT                              9
#define MOD_B2_GEN1_DEVICE                             "IC1"
#define MOD_B2_GEN1_ALG0_STAGE0_B2_ADDR                381
#define MOD_B2_GEN1_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B2_GEN1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN1_ALG0_STAGE0_B1_ADDR                382
#define MOD_B2_GEN1_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B2_GEN1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN1_ALG0_STAGE0_B0_ADDR                383
#define MOD_B2_GEN1_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B2_GEN1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B2_GEN1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN1_ALG0_STAGE0_A2_ADDR                384
#define MOD_B2_GEN1_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B2_GEN1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN1_ALG0_STAGE0_A1_ADDR                385
#define MOD_B2_GEN1_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B2_GEN1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN1_ALG0_DATA_ADR_ADDR                 386
#define MOD_B2_GEN1_ALG0_DATA_ADR_FIXPT                0x0000034B
#define MOD_B2_GEN1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(843)
#define MOD_B2_GEN1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN1_ALG0_DATAR_ADR_ADDR                387
#define MOD_B2_GEN1_ALG0_DATAR_ADR_FIXPT               0x00000354
#define MOD_B2_GEN1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(852)
#define MOD_B2_GEN1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN1_ALG0_COEFF_ADR_ADDR                388
#define MOD_B2_GEN1_ALG0_COEFF_ADR_FIXPT               0x00000180
#define MOD_B2_GEN1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(384)
#define MOD_B2_GEN1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN1_ALG0_LOOP_ADDR                     389
#define MOD_B2_GEN1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_GEN1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_GEN1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_GEN1 - General (2nd order)*/
#define MOD_B3_GEN1_COUNT                              9
#define MOD_B3_GEN1_DEVICE                             "IC1"
#define MOD_B3_GEN1_ALG0_STAGE0_B2_ADDR                390
#define MOD_B3_GEN1_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B3_GEN1_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN1_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN1_ALG0_STAGE0_B1_ADDR                391
#define MOD_B3_GEN1_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B3_GEN1_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN1_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN1_ALG0_STAGE0_B0_ADDR                392
#define MOD_B3_GEN1_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B3_GEN1_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_GEN1_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN1_ALG0_STAGE0_A2_ADDR                393
#define MOD_B3_GEN1_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B3_GEN1_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN1_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN1_ALG0_STAGE0_A1_ADDR                394
#define MOD_B3_GEN1_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B3_GEN1_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN1_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN1_ALG0_DATA_ADR_ADDR                 395
#define MOD_B3_GEN1_ALG0_DATA_ADR_FIXPT                0x0000035F
#define MOD_B3_GEN1_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(863)
#define MOD_B3_GEN1_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN1_ALG0_DATAR_ADR_ADDR                396
#define MOD_B3_GEN1_ALG0_DATAR_ADR_FIXPT               0x00000368
#define MOD_B3_GEN1_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(872)
#define MOD_B3_GEN1_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN1_ALG0_COEFF_ADR_ADDR                397
#define MOD_B3_GEN1_ALG0_COEFF_ADR_FIXPT               0x00000189
#define MOD_B3_GEN1_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(393)
#define MOD_B3_GEN1_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN1_ALG0_LOOP_ADDR                     398
#define MOD_B3_GEN1_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_GEN1_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_GEN1_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_GEN2 - General (2nd order)*/
#define MOD_B0_GEN2_COUNT                              9
#define MOD_B0_GEN2_DEVICE                             "IC1"
#define MOD_B0_GEN2_ALG0_STAGE0_B2_ADDR                399
#define MOD_B0_GEN2_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B0_GEN2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN2_ALG0_STAGE0_B1_ADDR                400
#define MOD_B0_GEN2_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B0_GEN2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN2_ALG0_STAGE0_B0_ADDR                401
#define MOD_B0_GEN2_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B0_GEN2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B0_GEN2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN2_ALG0_STAGE0_A2_ADDR                402
#define MOD_B0_GEN2_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B0_GEN2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN2_ALG0_STAGE0_A1_ADDR                403
#define MOD_B0_GEN2_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B0_GEN2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B0_GEN2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_GEN2_ALG0_DATA_ADR_ADDR                 404
#define MOD_B0_GEN2_ALG0_DATA_ADR_FIXPT                0x00000373
#define MOD_B0_GEN2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(883)
#define MOD_B0_GEN2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN2_ALG0_DATAR_ADR_ADDR                405
#define MOD_B0_GEN2_ALG0_DATAR_ADR_FIXPT               0x0000037C
#define MOD_B0_GEN2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(892)
#define MOD_B0_GEN2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN2_ALG0_COEFF_ADR_ADDR                406
#define MOD_B0_GEN2_ALG0_COEFF_ADR_FIXPT               0x00000192
#define MOD_B0_GEN2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(402)
#define MOD_B0_GEN2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B0_GEN2_ALG0_LOOP_ADDR                     407
#define MOD_B0_GEN2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B0_GEN2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_GEN2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B1_GEN2 - General (2nd order)*/
#define MOD_B1_GEN2_COUNT                              9
#define MOD_B1_GEN2_DEVICE                             "IC1"
#define MOD_B1_GEN2_ALG0_STAGE0_B2_ADDR                408
#define MOD_B1_GEN2_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B1_GEN2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN2_ALG0_STAGE0_B1_ADDR                409
#define MOD_B1_GEN2_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B1_GEN2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN2_ALG0_STAGE0_B0_ADDR                410
#define MOD_B1_GEN2_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B1_GEN2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B1_GEN2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN2_ALG0_STAGE0_A2_ADDR                411
#define MOD_B1_GEN2_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B1_GEN2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN2_ALG0_STAGE0_A1_ADDR                412
#define MOD_B1_GEN2_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B1_GEN2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B1_GEN2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_GEN2_ALG0_DATA_ADR_ADDR                 413
#define MOD_B1_GEN2_ALG0_DATA_ADR_FIXPT                0x00000387
#define MOD_B1_GEN2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(903)
#define MOD_B1_GEN2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN2_ALG0_DATAR_ADR_ADDR                414
#define MOD_B1_GEN2_ALG0_DATAR_ADR_FIXPT               0x00000390
#define MOD_B1_GEN2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(912)
#define MOD_B1_GEN2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN2_ALG0_COEFF_ADR_ADDR                415
#define MOD_B1_GEN2_ALG0_COEFF_ADR_FIXPT               0x0000019B
#define MOD_B1_GEN2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(411)
#define MOD_B1_GEN2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B1_GEN2_ALG0_LOOP_ADDR                     416
#define MOD_B1_GEN2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B1_GEN2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_GEN2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B2_GEN2 - General (2nd order)*/
#define MOD_B2_GEN2_COUNT                              9
#define MOD_B2_GEN2_DEVICE                             "IC1"
#define MOD_B2_GEN2_ALG0_STAGE0_B2_ADDR                417
#define MOD_B2_GEN2_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B2_GEN2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN2_ALG0_STAGE0_B1_ADDR                418
#define MOD_B2_GEN2_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B2_GEN2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN2_ALG0_STAGE0_B0_ADDR                419
#define MOD_B2_GEN2_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B2_GEN2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B2_GEN2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN2_ALG0_STAGE0_A2_ADDR                420
#define MOD_B2_GEN2_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B2_GEN2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN2_ALG0_STAGE0_A1_ADDR                421
#define MOD_B2_GEN2_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B2_GEN2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B2_GEN2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_GEN2_ALG0_DATA_ADR_ADDR                 422
#define MOD_B2_GEN2_ALG0_DATA_ADR_FIXPT                0x0000039B
#define MOD_B2_GEN2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(923)
#define MOD_B2_GEN2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN2_ALG0_DATAR_ADR_ADDR                423
#define MOD_B2_GEN2_ALG0_DATAR_ADR_FIXPT               0x000003A4
#define MOD_B2_GEN2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(932)
#define MOD_B2_GEN2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN2_ALG0_COEFF_ADR_ADDR                424
#define MOD_B2_GEN2_ALG0_COEFF_ADR_FIXPT               0x000001A4
#define MOD_B2_GEN2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(420)
#define MOD_B2_GEN2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B2_GEN2_ALG0_LOOP_ADDR                     425
#define MOD_B2_GEN2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B2_GEN2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_GEN2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B3_GEN2 - General (2nd order)*/
#define MOD_B3_GEN2_COUNT                              9
#define MOD_B3_GEN2_DEVICE                             "IC1"
#define MOD_B3_GEN2_ALG0_STAGE0_B2_ADDR                426
#define MOD_B3_GEN2_ALG0_STAGE0_B2_FIXPT               0x00000000
#define MOD_B3_GEN2_ALG0_STAGE0_B2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN2_ALG0_STAGE0_B2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN2_ALG0_STAGE0_B1_ADDR                427
#define MOD_B3_GEN2_ALG0_STAGE0_B1_FIXPT               0x00000000
#define MOD_B3_GEN2_ALG0_STAGE0_B1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN2_ALG0_STAGE0_B1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN2_ALG0_STAGE0_B0_ADDR                428
#define MOD_B3_GEN2_ALG0_STAGE0_B0_FIXPT               0x00800000
#define MOD_B3_GEN2_ALG0_STAGE0_B0_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_GEN2_ALG0_STAGE0_B0_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN2_ALG0_STAGE0_A2_ADDR                429
#define MOD_B3_GEN2_ALG0_STAGE0_A2_FIXPT               0x00000000
#define MOD_B3_GEN2_ALG0_STAGE0_A2_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN2_ALG0_STAGE0_A2_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN2_ALG0_STAGE0_A1_ADDR                430
#define MOD_B3_GEN2_ALG0_STAGE0_A1_FIXPT               0x00000000
#define MOD_B3_GEN2_ALG0_STAGE0_A1_VALUE               SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0)
#define MOD_B3_GEN2_ALG0_STAGE0_A1_TYPE                SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_GEN2_ALG0_DATA_ADR_ADDR                 431
#define MOD_B3_GEN2_ALG0_DATA_ADR_FIXPT                0x000003AF
#define MOD_B3_GEN2_ALG0_DATA_ADR_VALUE                SIGMASTUDIOTYPE_INTEGER_CONVERT(943)
#define MOD_B3_GEN2_ALG0_DATA_ADR_TYPE                 SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN2_ALG0_DATAR_ADR_ADDR                432
#define MOD_B3_GEN2_ALG0_DATAR_ADR_FIXPT               0x000003B8
#define MOD_B3_GEN2_ALG0_DATAR_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(952)
#define MOD_B3_GEN2_ALG0_DATAR_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN2_ALG0_COEFF_ADR_ADDR                433
#define MOD_B3_GEN2_ALG0_COEFF_ADR_FIXPT               0x000001AD
#define MOD_B3_GEN2_ALG0_COEFF_ADR_VALUE               SIGMASTUDIOTYPE_INTEGER_CONVERT(429)
#define MOD_B3_GEN2_ALG0_COEFF_ADR_TYPE                SIGMASTUDIOTYPE_INTEGER
#define MOD_B3_GEN2_ALG0_LOOP_ADDR                     434
#define MOD_B3_GEN2_ALG0_LOOP_FIXPT                    0x00000001
#define MOD_B3_GEN2_ALG0_LOOP_VALUE                    SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_GEN2_ALG0_LOOP_TYPE                     SIGMASTUDIOTYPE_INTEGER

/* Module B0_VOL - Single Volume*/
#define MOD_B0_VOL_COUNT                               2
#define MOD_B0_VOL_DEVICE                              "IC1"
#define MOD_B0_VOL_ALG0_GAIN1940ALGNS9_ADDR            435
#define MOD_B0_VOL_ALG0_GAIN1940ALGNS9_FIXPT           0x004026E7
#define MOD_B0_VOL_ALG0_GAIN1940ALGNS9_VALUE           SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.501187233627272)
#define MOD_B0_VOL_ALG0_GAIN1940ALGNS9_TYPE            SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_VOL_ALG1_GAIN1940ALGNS10_ADDR           436
#define MOD_B0_VOL_ALG1_GAIN1940ALGNS10_FIXPT          0x004026E7
#define MOD_B0_VOL_ALG1_GAIN1940ALGNS10_VALUE          SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.501187233627272)
#define MOD_B0_VOL_ALG1_GAIN1940ALGNS10_TYPE           SIGMASTUDIOTYPE_FIXPOINT

/* Module B1_VOL - Single Volume*/
#define MOD_B1_VOL_COUNT                               2
#define MOD_B1_VOL_DEVICE                              "IC1"
#define MOD_B1_VOL_ALG0_GAIN1940ALGNS11_ADDR           437
#define MOD_B1_VOL_ALG0_GAIN1940ALGNS11_FIXPT          0x0032F52C
#define MOD_B1_VOL_ALG0_GAIN1940ALGNS11_VALUE          SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.398107170553497)
#define MOD_B1_VOL_ALG0_GAIN1940ALGNS11_TYPE           SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_VOL_ALG1_GAIN1940ALGNS12_ADDR           438
#define MOD_B1_VOL_ALG1_GAIN1940ALGNS12_FIXPT          0x0032F52C
#define MOD_B1_VOL_ALG1_GAIN1940ALGNS12_VALUE          SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.398107170553497)
#define MOD_B1_VOL_ALG1_GAIN1940ALGNS12_TYPE           SIGMASTUDIOTYPE_FIXPOINT

/* Module B2_VOL - Single Volume*/
#define MOD_B2_VOL_COUNT                               2
#define MOD_B2_VOL_DEVICE                              "IC1"
#define MOD_B2_VOL_ALG0_GAIN1940ALGNS15_ADDR           439
#define MOD_B2_VOL_ALG0_GAIN1940ALGNS15_FIXPT          0x000CCCCC
#define MOD_B2_VOL_ALG0_GAIN1940ALGNS15_VALUE          SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.1)
#define MOD_B2_VOL_ALG0_GAIN1940ALGNS15_TYPE           SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_VOL_ALG1_GAIN1940ALGNS16_ADDR           440
#define MOD_B2_VOL_ALG1_GAIN1940ALGNS16_FIXPT          0x000CCCCC
#define MOD_B2_VOL_ALG1_GAIN1940ALGNS16_VALUE          SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.1)
#define MOD_B2_VOL_ALG1_GAIN1940ALGNS16_TYPE           SIGMASTUDIOTYPE_FIXPOINT

/* Module B3_VOL - Single Volume*/
#define MOD_B3_VOL_COUNT                               2
#define MOD_B3_VOL_DEVICE                              "IC1"
#define MOD_B3_VOL_ALG0_GAIN1940ALGNS17_ADDR           441
#define MOD_B3_VOL_ALG0_GAIN1940ALGNS17_FIXPT          0x00051884
#define MOD_B3_VOL_ALG0_GAIN1940ALGNS17_VALUE          SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0398107170553497)
#define MOD_B3_VOL_ALG0_GAIN1940ALGNS17_TYPE           SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_VOL_ALG1_GAIN1940ALGNS18_ADDR           442
#define MOD_B3_VOL_ALG1_GAIN1940ALGNS18_FIXPT          0x00051884
#define MOD_B3_VOL_ALG1_GAIN1940ALGNS18_VALUE          SIGMASTUDIOTYPE_FIXPOINT_CONVERT(0.0398107170553497)
#define MOD_B3_VOL_ALG1_GAIN1940ALGNS18_TYPE           SIGMASTUDIOTYPE_FIXPOINT

/* Module B3_DEL - Delay*/
#define MOD_B3_DEL_COUNT                               1
#define MOD_B3_DEL_DEVICE                              "IC1"
#define MOD_B3_DEL_DELAYAMT_ADDR                       443
#define MOD_B3_DEL_DELAYAMT_FIXPT                      0x00000001
#define MOD_B3_DEL_DELAYAMT_VALUE                      SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B3_DEL_DELAYAMT_TYPE                       SIGMASTUDIOTYPE_INTEGER

/* Module B2_DEL - Delay*/
#define MOD_B2_DEL_COUNT                               1
#define MOD_B2_DEL_DEVICE                              "IC1"
#define MOD_B2_DEL_DELAYAMT_ADDR                       444
#define MOD_B2_DEL_DELAYAMT_FIXPT                      0x00000001
#define MOD_B2_DEL_DELAYAMT_VALUE                      SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B2_DEL_DELAYAMT_TYPE                       SIGMASTUDIOTYPE_INTEGER

/* Module B1_DEL - Delay*/
#define MOD_B1_DEL_COUNT                               1
#define MOD_B1_DEL_DEVICE                              "IC1"
#define MOD_B1_DEL_DELAYAMT_ADDR                       445
#define MOD_B1_DEL_DELAYAMT_FIXPT                      0x00000001
#define MOD_B1_DEL_DELAYAMT_VALUE                      SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B1_DEL_DELAYAMT_TYPE                       SIGMASTUDIOTYPE_INTEGER

/* Module B0_DEL - Delay*/
#define MOD_B0_DEL_COUNT                               1
#define MOD_B0_DEL_DEVICE                              "IC1"
#define MOD_B0_DEL_DELAYAMT_ADDR                       446
#define MOD_B0_DEL_DELAYAMT_FIXPT                      0x00000001
#define MOD_B0_DEL_DELAYAMT_VALUE                      SIGMASTUDIOTYPE_INTEGER_CONVERT(1)
#define MOD_B0_DEL_DELAYAMT_TYPE                       SIGMASTUDIOTYPE_INTEGER

/* Module B0_Inv - Signal Invert*/
#define MOD_B0_INV_COUNT                               2
#define MOD_B0_INV_DEVICE                              "IC1"
#define MOD_B0_INV_ALG0_EQ1940INVERT1GAIN_ADDR         447
#define MOD_B0_INV_ALG0_EQ1940INVERT1GAIN_FIXPT        0x00800000
#define MOD_B0_INV_ALG0_EQ1940INVERT1GAIN_VALUE        SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B0_INV_ALG0_EQ1940INVERT1GAIN_TYPE         SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B0_INV_ALG1_EQ1940INVERT2GAIN_ADDR         448
#define MOD_B0_INV_ALG1_EQ1940INVERT2GAIN_FIXPT        0x00800000
#define MOD_B0_INV_ALG1_EQ1940INVERT2GAIN_VALUE        SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B0_INV_ALG1_EQ1940INVERT2GAIN_TYPE         SIGMASTUDIOTYPE_FIXPOINT

/* Module B1_Inv - Signal Invert*/
#define MOD_B1_INV_COUNT                               2
#define MOD_B1_INV_DEVICE                              "IC1"
#define MOD_B1_INV_ALG0_EQ1940INVERT3GAIN_ADDR         449
#define MOD_B1_INV_ALG0_EQ1940INVERT3GAIN_FIXPT        0x00800000
#define MOD_B1_INV_ALG0_EQ1940INVERT3GAIN_VALUE        SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B1_INV_ALG0_EQ1940INVERT3GAIN_TYPE         SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B1_INV_ALG1_EQ1940INVERT4GAIN_ADDR         450
#define MOD_B1_INV_ALG1_EQ1940INVERT4GAIN_FIXPT        0x00800000
#define MOD_B1_INV_ALG1_EQ1940INVERT4GAIN_VALUE        SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B1_INV_ALG1_EQ1940INVERT4GAIN_TYPE         SIGMASTUDIOTYPE_FIXPOINT

/* Module B2_Inv - Signal Invert*/
#define MOD_B2_INV_COUNT                               2
#define MOD_B2_INV_DEVICE                              "IC1"
#define MOD_B2_INV_ALG0_EQ1940INVERT7GAIN_ADDR         451
#define MOD_B2_INV_ALG0_EQ1940INVERT7GAIN_FIXPT        0x00800000
#define MOD_B2_INV_ALG0_EQ1940INVERT7GAIN_VALUE        SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B2_INV_ALG0_EQ1940INVERT7GAIN_TYPE         SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B2_INV_ALG1_EQ1940INVERT8GAIN_ADDR         452
#define MOD_B2_INV_ALG1_EQ1940INVERT8GAIN_FIXPT        0x00800000
#define MOD_B2_INV_ALG1_EQ1940INVERT8GAIN_VALUE        SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B2_INV_ALG1_EQ1940INVERT8GAIN_TYPE         SIGMASTUDIOTYPE_FIXPOINT

/* Module B3_Inv - Signal Invert*/
#define MOD_B3_INV_COUNT                               2
#define MOD_B3_INV_DEVICE                              "IC1"
#define MOD_B3_INV_ALG0_EQ1940INVERT5GAIN_ADDR         453
#define MOD_B3_INV_ALG0_EQ1940INVERT5GAIN_FIXPT        0x00800000
#define MOD_B3_INV_ALG0_EQ1940INVERT5GAIN_VALUE        SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_INV_ALG0_EQ1940INVERT5GAIN_TYPE         SIGMASTUDIOTYPE_FIXPOINT
#define MOD_B3_INV_ALG1_EQ1940INVERT6GAIN_ADDR         454
#define MOD_B3_INV_ALG1_EQ1940INVERT6GAIN_FIXPT        0x00800000
#define MOD_B3_INV_ALG1_EQ1940INVERT6GAIN_VALUE        SIGMASTUDIOTYPE_FIXPOINT_CONVERT(1)
#define MOD_B3_INV_ALG1_EQ1940INVERT6GAIN_TYPE         SIGMASTUDIOTYPE_FIXPOINT

#endif
